﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Collections;

namespace Ice.Net.Ecommerce.BusinessObjects.Common
{
	public class VISTACARTHelper
	{
		public static CurrentUser CurrentUser
		{
			get 
			{
				// WebService doesn't support Session !!!

				CurrentUser cuser = CacheProvider.RequestStore.Retrieve<CurrentUser>();
				if (cuser == null)
				{
					cuser = new CurrentUser();
					CacheProvider.RequestStore.Save(cuser);
				}
				return cuser;
			}
		}

		public static void CleanRequestStore()
		{
			CacheProvider.RequestStore.RemoveAll();
		}

		public static AppDefaults AppDefaults
		{
			get 
			{
				// get reference from Application variable
				AppDefaults app = CacheProvider.ApplicationStore.Retrieve<AppDefaults>();
				if (app == null)
				{
					app = new AppDefaults();
					CacheProvider.ApplicationStore.Save(app);
				}

				return app;
			}
		}

		public static void CleanApplicationStore()
		{
			CacheProvider.ApplicationStore.RemoveAll();

			IDictionaryEnumerator enumerator = HttpContext.Current.Cache.GetEnumerator();
			while (enumerator.MoveNext())
			{
				HttpContext.Current.Cache.Remove(enumerator.Key + "");
			}
		}


	}
}
