﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using System.Linq;
using Ice.Net.Ecommerce.CacheProvider;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class AppGlobalSetting 
	{
		#region Database methods


		/// <summary>
		/// Load the first settings row from database where IsActive == true
		/// </summary>
		/// <returns></returns>
		public static AppGlobalSetting GetDefault()
		{
			// load from db the first active object (IsActive == true)
			AppGlobalSetting a = new Query().Where(db.AppGlobalSetting.IsActive, true).OrderBy(db.AppGlobalSetting.Ordinal, true).Take(1).ToList<AppGlobalSetting>().FirstOrDefault();
			
			if (a != null)
			{
				return a;
			}
			
			// can't read from database
			Common.Logging.WriteError("Can't read default AppGlobalSettingItem from DB");
			return null;
		}

		#endregion


		public SSLModeUtility.SSLModeEnum SSLMode
		{
			get { return (SSLModeUtility.SSLModeEnum)this.SSLModeID; }
		}

		#region Database methods overrides

		/// <summary>
		/// Save to database and remove cached items from cache.
		/// </summary>
		/// <returns></returns>
		public override AppGlobalSetting SaveToDB(WriteModeEnum mode)
		{
			ApplicationStore.RemoveAll();
			return base.SaveToDB(mode);
		}

		#endregion

	}
}
