﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class LicenseInfoCollection : List<LicenseInfo>
	{
		#region Database methods
		// Database methods

		public static List<LicenseInfo> LoadByUserID(int userID)
		{
			return LoadByUserID(userID, false);
		}

		public static List<LicenseInfo> LoadByUserID(int userID, bool trialOnly)
		{
			return new Query()
			.Where(db.LicenseInfo.UserID, userID)
			.Case(trialOnly, o => o.Where(db.LicenseInfo.IsTrial, trialOnly))
			.Take(1000)
			.ToList<LicenseInfo>();
		}

		public static List<LicenseInfo> LoadByOrderID(int orderID)
		{
			return new Query()
			.Where(db.LicenseInfo.OrderID, orderID)
			.Take(1000)
			.ToList<LicenseInfo>();
		}


		#endregion
	}
}
