﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;
using System.Xml;
using System.Configuration;
using System.Web;
using System.Linq;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class LicenseInfo 
	{
		#region Custom methods & properties

		private List<LicensedSite> mLicensedSiteCollection = null;

		public List<LicensedSite> GetLicensedSiteCollection()
		{
			if (mLicensedSiteCollection == null)
			{
				mLicensedSiteCollection = LicensedSiteCollection.LoadByLicenseInfoID(this.LicenseInfoID);
			}
			return mLicensedSiteCollection;
		}

		public List<LicensedSite> LicensedSiteList2
		{
			get { return GetLicensedSiteCollection(); }
			set 
			{
				List<LicensedSite> sites = value;
				mLicensedSiteCollection = new List<LicensedSite>();
				foreach (LicensedSite site in sites)
				{
					mLicensedSiteCollection.Add(site);
				}
			}
		}

		public string ToGCartLicenseXml()
		{
			return BusinessObjects.Common.LicenseHelper.ToGCartLicenseXmlInternal(this);
		}

		public string GetSitesString()
		{
			return this.GetLicensedSiteCollection().Select(o => o.SiteAddress).ToStringJoined(", ");
		}

		#endregion

		#region Database methods
		// Database methods

		/// <summary>
		/// Load LicenseInfo by UserID or Email
		/// </summary>
		/// <param name="userID"></param>
		/// <returns></returns>
		public static LicenseInfo LoadTrialLicense(int userID, string userEmail)
		{
			return new Query()
			.Where(db.LicenseInfo.IsTrial, true)
			.Where(db.LicenseInfo.UserID, userID, DBWhereKeyOperator.Equals, DBWhereKeyLogic.And, DBWhereBrackets.Open)
			.Where(db.LicenseInfo.Email, userEmail, DBWhereKeyOperator.Equals, DBWhereKeyLogic.Or, DBWhereBrackets.Close)
			.ToList<LicenseInfo>()
			.FirstOrDefault();
		}

		/// <summary>
		/// Saves LicensedSiteCollection too
		/// </summary>
		/// <returns></returns>
		public override LicenseInfo SaveToDB(WriteModeEnum mode)
		{
			base.SaveToDB(mode);
			List<LicensedSite> licSiteCollection = GetLicensedSiteCollection();
			foreach (LicensedSite lsite in licSiteCollection)
			{
				lsite.LicenseInfoID = this.LicenseInfoID;
			}
			licSiteCollection.ForEach(o => o.SaveToDB());
			return this;
		}

		public override bool DeleteFromDB()
		{
			GetLicensedSiteCollection().ForEach(o => o.DeleteFromDB());
			return base.DeleteFromDB();
		}

		#endregion


	}

}
