﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class OrderCollection
	{
		#region Database methods
		// Database methods

		/// <summary>
		/// Load by UserID, ordered by OrderID DESC
		/// </summary>
		/// <param name="userID"></param>
		/// <returns></returns>
		public static List<Order> LoadByUserID(int userID, int maxRecordsToLoad)
		{
			return new Query()
			.Where(db.Order.UserID, userID)
			.OrderBy(db.Order.OrderID, true)
			.Take(maxRecordsToLoad)
			.ToList<Order>();
		}

		public static List<Order> LoadPaged(int recordsPerPage, int currentPageIndex, object orderByColumn, bool orderAsc)
		{
			return new Query()
			.Select(new SqlName(db.Order + ".*"), db.User.Username, db.User.Email)
			.From(db.Order)
			.LeftJoin(db.User, db.Order.UserID, db.User.UserID)
			.Case(orderByColumn != null, o => o.OrderBy(new SqlName(orderByColumn + ""), orderAsc ? false : true))
			.Skip(currentPageIndex * recordsPerPage)
			.Take(recordsPerPage)
			.ToList<Order>();
		}

		#endregion
	}
}
