﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class State 
	{
		#region Public properties

		private Country mCountry = null;

		public Country GetCountry()
		{
			if (mCountry == null)
			{
				mCountry = new Country();
				mCountry.LoadFromDB(this.CountryID);
			}
			return mCountry;
		}

		public string CountryName
		{
			get {return this.GetCountry().Name; }
		}

		private Tax mTax = null;

		public Tax GetTax()
		{
			if (mTax == null)
			{
				mTax = new Tax();
				mTax.LoadFromDB(this.TaxID);
			}
			return mTax;
		}

		public string TaxName
		{
			get { return this.GetTax().Name; }
		}

		#endregion

		#region Database methods
		// Database methods

		public static State LoadBySymbol(string symbol)
		{
			return new Query<State>().Where(o => o.Symbol == symbol).FirstOrDefault();
		}

		public static State LoadByName(string name)
		{
			return new Query<State>().Where(o => o.Name == name).FirstOrDefault();
		}

		#endregion

		#region Database methods overrides


		#endregion

	}

}
