﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class UserInRoleCollection : List<UserInRole>
	{
		#region Database methods
		// Database methods

		/// <summary>
		/// Delete all by UserID.
		/// </summary>
		/// <param name="userID"></param>
		/// <returns></returns>
		public static int DeleteByUserID(int userID)
		{
			return new Query().Delete(db.UserInRole)
			.Where(db.UserInRole.UserID, userID)
			.ExecuteNonQuery<UserInRole>();
		}

		public static List<UserInRole> LoadByUserID(int userID)
		{
			return new Query()
			.Where(db.UserInRole.UserID, userID)
			.Take(1000)
			.ToList<UserInRole>();
		}

		public static int CountUsersByRoleID(int roleID)
		{
			return new Query()
			.Where(db.UserInRole.RoleID, roleID)
			.ToList<UserInRole>().Count;
		}

		#endregion
	}
}
