﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data.SqlClient;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;

namespace Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART
{
	public partial class WebPage
	{
		public enum NameEnum
		{
			TermsAndConditions = 1,
			PrivacyPolicy = 2,
			OrderCompletePage = 3,
			CVVExplanation = 4,
			PaymentDoneEmail = 5
		}

		#region Static methods

		public static string GetContent(NameEnum name)
		{
			return GetContent((int)name);
		}

		public static string GetContent(int webPageID)
		{
			WebPage dc = new WebPage();
			if (dc.LoadFromDB(webPageID) && dc.IsActive)
			{
				return dc.Content;
			}
			else
			{
				return "";
			}
		}

		#endregion

		#region Database methods overrides

		public override bool DeleteFromDB()
		{
			// delete from campaigns
			WebPageInCampaignCollection webPageInCampaigns = new WebPageInCampaignCollection();
			webPageInCampaigns.DeleteByWebPageID(this.WebPageID);

			// delete from categories
			WebPageInCategoryCollection webPageInCategory = new WebPageInCategoryCollection();
			webPageInCategory.DeleteByWebPageID(this.WebPageID);

			return base.DeleteFromDB();
		}

		public static WebPage LoadFromDBByName(string name)
		{
			return new Query<WebPage>().Where(o => o.Name == name).FirstOrDefault();
		}

		#endregion

		#region Public static methods

		public static WebPage LoadWebPage(NameEnum webPageName)
		{
			return LoadWebPage((int)webPageName);
		}

		public static WebPage LoadWebPage(int webPageID)
		{
			WebPage webPage = new WebPage();
			webPage.LoadFromDB(webPageID);
			return webPage;
		}

		#endregion

		#region Public methods

		public bool IsInCampaign(Campaign campaign)
		{
			return WebPageInCampaign.LoadByWebPageIDAndCampaignID(this.WebPageID, campaign.CampaignID) != null;
		}

		public bool IsInCategory(Category category)
		{
			return WebPageInCategory.LoadByWebPageIDAndCategoryID(this.WebPageID, category.CategoryID) != null;
		}

		#endregion
	}

}
