﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ice.Net.Ecommerce.BusinessObjects.Gallery
{
	public class GalleryImage
	{
		public string name;
		public int size;
		public string lastmod;
		public string url;  // absolute http path
		public string file; // physical file

		public int height;
		public int width;
		public int thumbHeight;
		public int thumbWidth;
		public int marginTop;
		public int marginLeft;

		public string relativeHttpPath; // relative to the asp.net applicaton root, example: /gallery/gallery1/tshirt.gif

		static string[] mFileTypes = new string[] { "png", "gif", "jpg" };

		/// <summary>
		/// <para>Returns true if file extension is supported.</para>
		/// <para>Supported types: png, gif, jpg</para>
		/// </summary>
		/// <param name="filename"></param>
		/// <returns></returns>
		public static bool IsSupported(string filename)
		{
			foreach (string filetype in mFileTypes)
			{
				if (filename.EndsWith(filetype))
				{
					return true;
				}
			}
			return false;
		}
	}

}
