﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

namespace Ice.Net.Ecommerce.BusinessObjects.Gallery
{
	public class GalleryNode
	{
		public bool IsRoot = false;
		public string ParentPhysicalPath = null;
		public string ParentHttpGalleryPath = null;
		public string GalleryDirectory = "";
		public string GalleryPhysicalPath = "";
		public string HttpGalleryPath = "";

		public GalleryNode()
		{
		}

		public GalleryNode(GalleryNode parentNode, string galleryDirectory)
		{
			if (galleryDirectory == null || galleryDirectory.Length == 0)
			{
				this.GalleryDirectory = System.Configuration.ConfigurationManager.AppSettings["GalleryRoot"].Trim('/');
			}
			else
			{
				this.GalleryDirectory = galleryDirectory;
			}

			if (parentNode == null)
			{
				this.IsRoot = true;
				this.GalleryPhysicalPath = HttpContext.Current.Request.PhysicalApplicationPath + this.GalleryDirectory + "\\";
				this.HttpGalleryPath = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRootCurrent + this.GalleryDirectory + "/";
			}
			else
			{
				this.ParentPhysicalPath = parentNode.GalleryPhysicalPath;
				this.ParentHttpGalleryPath = parentNode.HttpGalleryPath;
				this.GalleryPhysicalPath = this.ParentPhysicalPath + this.GalleryDirectory + "\\";
				this.HttpGalleryPath = this.ParentHttpGalleryPath + this.GalleryDirectory + "/";
			}

			//this.ChildNodes = GetChildren(this.GalleryPhysicalPath);
		}

		public List<GalleryNode> GetChildren()
		{
			List<GalleryNode> children = new List<GalleryNode>();
			// load child direcotries
			string[] childDirectories = System.IO.Directory.GetDirectories(this.GalleryPhysicalPath);
			foreach (string directory in childDirectories)
			{
				string dirName = GetNameOnly(directory);
				children.Add(new GalleryNode(this, dirName));
			}
			return children;
		}

		private string GetNameOnly(string fullPath)
		{
			string nameOnly = fullPath.Substring(fullPath.LastIndexOf("\\") + 1);
			return nameOnly;
		}

	}
}
