﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Mail;
using System.Net.Mime;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using Ice.Net.Ecommerce.BusinessObjects.Common;

namespace Ice.Net.Ecommerce.EmailUtility
{
	public class EmailSenderImpl
	{
		public static List<string> SendEmails(string server, int port, string username, string password, string subject, string htmlBody, bool isBodyHtml, List<Attachment> attachments, string fromEmail, string fromName, string[] toEmails)
		{
			List<string> failedEmails = new List<string>();

			foreach (string toEmail in toEmails)
			{
				try
				{
					MailMessage message = EmailUtility.CreateMailMessage(fromEmail, toEmail, fromName, subject, htmlBody, isBodyHtml, attachments);

					SmtpClient smtp = EmailUtility.CreateSmtpClient( server, port, username, password);

					smtp.Timeout = 30000;
					smtp.Send(message);
					//emailResult.Add("SENT " + toEmail + "<br/>");
				}
				catch (Exception ex)
				{
					// sending failed
					failedEmails.Add(toEmail + " ### " + ex.Message);
				}
			}

			return failedEmails;

		}

		public static List<string> SendEmails(string subject, string htmlBody, bool isBodyHtml, List<Attachment> attachments, string fromEmail, string fromName, string[] toEmails)
		{
			return SendEmails(
						VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.EmailServer,
						VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.EmailPort,
						VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.EmailUsername,
						VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.EmailPassword,
						subject,
						htmlBody,
						isBodyHtml,
						attachments,
						fromEmail,
						fromName,
						toEmails);
		}

	}
}