﻿using System;
using System.Collections.Generic;
using System.Text;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;

namespace Ice.Net.Ecommerce.OrderContentForEmail
{
	public class AddressBuilder
	{
		StringBuilder mSb = new StringBuilder();

		public static string GetHtml(int? addressID)
		{
			Address address = new Address();
			if (address.LoadFromDB(addressID))
			{
				return GetHtml(address);
			}
			else
			{
				return "";
			}
		}

		public static string GetHtml(Address address)
		{
			AddressBuilder addrBuilder = new AddressBuilder();
			
			addrBuilder.mSb.Append(@"<table>
");

			addrBuilder.AppendRow(address.FirstName);
			addrBuilder.AppendRow(address.LastName);
			addrBuilder.AppendRow(address.Address1);
			addrBuilder.AppendRow(address.City);
			addrBuilder.AppendRow(address.Zip);
			addrBuilder.AppendRow(address.GetCountry().Name);
			addrBuilder.AppendRow(address.GetState().Name);
			addrBuilder.AppendRow(address.PhoneNo);
			addrBuilder.AppendRow(address.MobileNo);
			addrBuilder.AppendRow(address.Email);
			addrBuilder.AppendRow(address.WebSite);
			addrBuilder.AppendRow(address.Notes);

			addrBuilder.mSb.Append(@"
</table>");

			return addrBuilder.mSb.ToString();
		}

		private void AppendRow(string text)
		{
			this.mSb.Append(String.Format(@"
<tr><td>{0}</td></tr>", text));
		}
	}
}
