﻿using System;
using System.Collections.Generic;
using System.Text;
using Ice.Orm.Core.Entity; using Ice.Orm.Core.Criteria;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;

namespace Ice.Net.Ecommerce.OrderContentForEmail
{
	internal class EmailBuilder
	{
		public static string GetHtml(Order order)
		{
			string customerBillingAddress = AddressBuilder.GetHtml(order.BillingAddressID);
			string customerShippingAddress = AddressBuilder.GetHtml(order.ShippingAddressID);
			string orderHtml = OrderBuilder.GetHtml(order);

			return String.Format(@"

<table cellpadding='0px' cellspacing='10px' style='width:600px;'>
	<tr><td colspan='2' style='background-color:#E8E8EB; border:solid 2px #E8E8EB; font-weight:bold;font-size:16px; height:30px;'>Order ID: {5}</td></tr>
	<tr>
		<td style='width:50%; vertical-align:top;'>
			<div style='background-color:#E8E8EB; border:solid 2px #E8E8EB'><b>{3}</b></div>
			{0}
		</td>
		<td style='width:50%; vertical-align:top;'>
			<div style='background-color:#E8E8EB; border:solid 2px #E8E8EB'><b>{4}</b></div>
			{1}
		</td>
	</tr>
	<tr>
		<td colspan='2'>
			{2}
		</td>
	</tr>
<tr><td colspan='2' style='background-color:#E8E8EB; border:solid 2px #E8E8EB; font-weight:bold;font-size:16px;height:30px;'>&nbsp;</td></tr>
</table>
",
		customerBillingAddress,
		customerShippingAddress,
		orderHtml,
		Message.GetContent(Message.NameEnum.BillingAddress),
		Message.GetContent(Message.NameEnum.ShippingAddress),
		order.OrderID
);

		}
	}
}
