﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text.RegularExpressions;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal abstract class BasePG
	{
		public abstract string GetControlPanelHtml();
		public abstract PGResult GetFormWithParameters(Order order);
		public abstract PGStatus GetReceivedStatus(HttpContext context);
		public abstract PGNameEnum PGNameEnum { get; }
		public abstract PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order);
		/// <summary>
		/// true if uses API (Authorize.net, FreePayDK)
		/// </summary>
		public abstract bool AIMMethod { get; }

		public string PGName 
		{
			get { return this.PGNameEnum.ToString(); } 
		}

		/// <summary>
		/// OrderComplete.aspx
		/// </summary>
		protected static string OrderCompletePage
		{
			get { return "OrderComplete.aspx"; }
		}

		private PaymentType mPaymentType = null;

		public PaymentType PaymentType
		{
			get
			{
				if (mPaymentType == null)
				{
					mPaymentType = PaymentType.LoadByPGName(this.PGName);
					if (mPaymentType == null)
					{
						// payment type not found by name
						throw new Exception("Can't load payment type: " + this.PGName);
					}
				}
				return mPaymentType;
			}
			set
			{
				if (value.PGName == this.PGName)
				{
					mPaymentType = value;
				}
			}
		}

		static Regex reRep = new Regex(@"<[^\255]*?>");

		protected string RemoveHtmlTags(string strhtml)
		{
			return reRep.Replace(strhtml, "");
		}

		public string GetFinalForm(int orderID)
		{
			return String.Format(@"
<form method='get' action='{0}'>
<input type='hidden' name='p' value='{2}'/>
<input type='hidden' name='oid' value='{1}'/>
</form>",
		BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot,
		orderID,
		Category.Shortcut.ordercomplete + "");
		}


	}
}
