﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text.RegularExpressions;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PG2CheckOut : BasePG
	{
		public override bool AIMMethod
		{
			get { return false; }
		}
		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._2CheckOut; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}

		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return String.Format(@"

<!--2CHECKOUT CONTROL PANEL-->
<table cellpadding='0px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>
<tr><td >Demo</td><td><input type='checkbox' name='IsDemo' /></td></tr>
<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >Vendor ID</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>
<tr><td >Secret Word</td><td><input name='MerchantKey' type='text' style='width:255px;' /></td></tr>
<tr><td >Use SPP</td><td><input name='IsSPPUsed' type='checkbox' /></td></tr>
<tr><td >Skip Cart Review</td><td><input name='IsSkipCartReview' type='checkbox' /></td></tr>
<tr><td >Description<br/></td><td><textarea id='textareaPTDescription'  name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='textareaPTLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>

<tr><td colspan='2' style='text-align:center;height:60px;background-image:url({0}admin/pglogo/2checkout.gif); background-repeat:no-repeat; background-position:center center'>&nbsp;</td></tr>
<tr><td colspan='2' style='text-align:center; height:20px'><a href='http://www.2Checkout.com' target='_blank'><b> http://www.2Checkout.com </b></a></td></tr>
<tr><td></td><td><div style='display:none'>
<!--quick help content-->
<b>IMPORTANT: 2Checkout accepts USD only! Default shop currency should be USD, otherwise price is converted into USD using shop currency rate before sending to 2checkout. Shop currency exchange rates has to be updated regularly. 2co uses their own exchange rates.</b><br /><br />
<b>Vendor ID</b> your 2checkout assigned Vendor ID <br/>
<b>Secret Word</b> enter the same word here and at 2checkout web page.<br/>
<b>Use SPP</b> if checked, use Single Page Payment Routine (otherwise Multi-page Payment Routine).<br/>
<b>Skip Cart Review</b> if checked, skip cart review, PayPal can't be  used!<br />
<b>Demo Mode</b> if checked, transactions will be in demo mode.<br/>
<b>Diagnostic Mode</b> any callback from active payment gateway will be logged into <em>[ticks].txt</em> file saved into App_Data directory, directory must have write permissions. <br/>
<br/>
Log into your 2CheckOut.com account, open page https://www.2checkout.com/2co/admin/look_and_feel/ <br/>
and setup parameters:<br/> 
<b>Secret Word: </b> Enter the secret word. <br /> 
<b>Approved URL: </b>{0}{1}<br /> 
<b>Pending URL: </b>{0}{1}<br /> 
<b>Direct Return: </b> leave it's default value No, but works with Yes too. <br />
</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>
",
	mSiteRoot, 
	OrderCompletePage
 
 );

		}

		#endregion


		//2checkout currency conversion:
		//Price sent to 2co web site MUST be in USD always. They understand amount to be in USD, doesn't matter which currency we send with tco_currency paramter.
		//If we send tco_currency parameter which is not USD, 2co convert amount from USD into selected currency using their own exchange rate.

		// USER DEPENDING PARAMETERS
		private static string mTransactionUrl = "https://www2.2checkout.com/2co/buyer/purchase"; // standard checkout
		private static string mSPPTransactionUrl = "https://www.2checkout.com/checkout/spurchase"; //single page purchase routine

		string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // example: http://www.iceasp.net/

		// separate dollars from cents and place dot between them
		// 2checkout requires format: dollars.cents, some languages places "," between !!!!

		private static Currency mUSDCurrency = null;
		/// <summary>
		/// If price is not in USD, convert it into USD
		/// </summary>
		/// <param name="amount"></param>
		/// <returns></returns>
		private decimal ConvertToUSDCurrency(decimal amount)
		{
			if (mUSDCurrency == null && BusinessObjects.Common.VISTACARTHelper.AppDefaults.Currency.ISOCode != "USD")
			{
				if ((mUSDCurrency = Currency.LoadByISOCode("USD")) != null && mUSDCurrency.IsActive)
				{
					// ok, convert prices from shop default currency into USD because 2checkout.net accepts value in USD only
				}
				else
				{
					mUSDCurrency = null;
					throw new Exception("Can't load USD currency, conversion is not possible!");
				}
			}

			if (mUSDCurrency != null)
			{
				// convert from shop default currency into USD
				amount = BusinessObjects.Common.CurrencyUtility.ConvertPrice(amount, mUSDCurrency, BusinessObjects.Common.VISTACARTHelper.AppDefaults.Currency);
			}
			
			return amount;
		}

		/// <summary>
		/// amount sent to 2co web site MUST be in USD always, if we change currency using tco_currency parameter, 2co convert value to selected currency 
		/// </summary>
		/// <param name="amount"></param>
		/// <returns></returns>
		private string GetAmountToPay(decimal amount) // 
		{
			amount = ConvertToUSDCurrency(amount);

			string strtotal = amount.ToString("n2");
			string dollars = strtotal.Substring(0, strtotal.Length - 3);
			string cents = strtotal.Substring(strtotal.Length - 2);
			dollars = dollars.Replace(",", ""); // remove , if any left
			dollars = dollars.Replace(".", ""); // remove . if any
			strtotal = dollars + "." + cents;
			return strtotal;
		}

		private string GetTransactionURL()
		{
			if (base.PaymentType.IsSPPUsed.GetValueOrDefault())
			{
				return mSPPTransactionUrl;
			}
			else
			{
				return mTransactionUrl;
			}
		}

		private string GetForm(Order order)
		{
			return (String.Format("<form method=\"post\" action=\"{0}\">\r\n{1}</form>", GetTransactionURL(), GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else
		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();

			nv.Add("sid", base.PaymentType.MerchantId);

			nv.Add("total", GetAmountToPay(order.RedundantTotalToPay));
			nv.Add("cart_order_id", order.OrderID + "");
			
			if (base.PaymentType.IsDemo == true)
			{
				nv.Add("demo", "Y");
			}
			nv.Add("fixed", "Y"); // fixed=Y to remove continue shopping button from 2CO.com
			nv.Add("merchant_web_site", mSiteRoot);

			//new parameters
			nv.Add("sh_cost", GetAmountToPay(order.RedundantShippingPrice));

			//price must be sent in USD always, than 2co converts it into currency selected by user
			nv.Add("tco_currency", BusinessObjects.Common.VISTACARTHelper.CurrentUser.Currency.ISOCode );
			// this sucks! It means that Default Shop Currency MUST be USD or we have to convert price into USD before we send it to 2co - exchange rate is usully different on 2co side!?

			// id_type : 
			//	value 1 - vendor's product ids will be used
			// value 2 - 2co product ids will be used
			nv.Add("id_type", "1"); //value 1: vendor's product ids will be used

			nv.Add("pay_method", "CC");// - CC for Credit Card, CK for check, PPI for PayPal, PPL for PayPal Pay Later, or FXS for FXSource. 

			if (base.PaymentType.IsSkipCartReview.GetValueOrDefault())
			{
				nv.Add("skip_landing", "1");// - If set to 1 it will skip the order review page of the purchase routine, but show billing address info
			}

			int nn = 1;
			foreach (OrderDetail det in order.GetOrderDetailCollection())
			{
				//encode productid and name to avoid ' "" chars
				nv.Add("c_prod_" + nn, det.ProductID + "," + det.Quantity);
				nv.Add("c_name_" + nn, RemoveHtmlTags( det.GetProduct().Name));
				nv.Add("c_price_" + nn, GetAmountToPay(det.RedundantSalePrice));
				nv.Add("c_description_" + nn, RemoveHtmlTags(det.GetProduct().ShortDescription));

				string tengible = "Y";
				if (det.RedundantWeight <= 0)
				{
					tengible = "N";
				}
				nv.Add("c_tangible_" + nn, tengible);
				nn++;
			}

			#region Authorize.net address parameters (accepted by 2CO)

			//////Address billingAddress = new Address();
			//////if (billingAddress.LoadFromDBByIdentity(order.BillingAddressID))
			//////{
			//////    // billing address
			//////    nv.Add("x_First_Name", billingAddress.FirstName);
			//////    nv.Add("x_Last_Name", billingAddress.LastName);
			//////    nv.Add("x_Phone", billingAddress.PhoneNo);
			//////    nv.Add("x_Email", billingAddress.Email);
			//////    nv.Add("x_Address", billingAddress.Address1);
			//////    nv.Add("x_City", billingAddress.City);
			//////    nv.Add("x_Zip", billingAddress.Zip);
			//////    nv.Add("x_State", billingAddress.GetState().Symbol);
			//////    nv.Add("x_Country", billingAddress.GetCountry().Symbol);
			//////}

			//////Address shippingAddress = new Address();
			//////if(shippingAddress.LoadFromDBByIdentity(order.ShippingAddressID))
			//////{
			//////    nv.Add("x_Ship_To_First_Name", shippingAddress.FirstName);
			//////    nv.Add("x_Ship_To_Last_Name", shippingAddress.LastName);
			//////    nv.Add("x_Ship_To_Address", shippingAddress.Address1);
			//////    nv.Add("x_Ship_To_City", shippingAddress.City);
			//////    nv.Add("x_Ship_To_Country", shippingAddress.GetCountry().Symbol);
			//////    nv.Add("x_Ship_To_State", shippingAddress.GetState().Symbol);
			//////    nv.Add("x_Ship_To_Zip", shippingAddress.Zip);
			//////}

			#endregion

			Address billingAddress = new Address();
			if (billingAddress.LoadFromDB(order.BillingAddressID))
			{
				nv.Add("first_name", billingAddress.FirstName);
				nv.Add("middle_initial", billingAddress.MiddleName);
				nv.Add("last_name", billingAddress.LastName);
				////nv.Add("card_holder_name", billingAddress.FirstName + " " + billingAddress.MiddleName + " " + billingAddress.LastName);
				nv.Add("street_address", billingAddress.Address1);
				nv.Add("street_address2", billingAddress.Address2);
				nv.Add("city", billingAddress.City);
				nv.Add("state", billingAddress.GetState().Symbol);
				nv.Add("zip", billingAddress.Zip);
				nv.Add("country", billingAddress.GetCountry().Symbol);
				nv.Add("email", billingAddress.Email);
				nv.Add("phone", billingAddress.PhoneNo);
				nv.Add("phone_extension", billingAddress.PhoneExtension);
			}

			Address shippingAddress = new Address();
			if (shippingAddress.LoadFromDB(order.ShippingAddressID))
			{
				nv.Add("ship_name", shippingAddress.FirstName + " " + shippingAddress.LastName);
				nv.Add("ship_street_address", shippingAddress.Address1);
				nv.Add("ship_street_address2", shippingAddress.Address2);
				nv.Add("ship_city", shippingAddress.City);
				nv.Add("ship_state", shippingAddress.GetState().Symbol);
				nv.Add("ship_zip", shippingAddress.Zip);
				nv.Add("ship_country", shippingAddress.GetCountry().Symbol);
			}

			return nv.ToFormPOSTInputs();
		}

		#region form data example

		// DATA RECEIVED FROM PAYMENT GATEWAY
		/* 2checkout sends next data:
		 <form action="http://loclahost.net/cb.aspx" method="post"> 
		 <input type="hidden" name="sid" value="504845" />
		 <input type="hidden" name="fixed" value="Y" />
		 <input type="hidden" name="key" value="A8308D8551A3D60B06AEC434A0F462EA" />
		 <input type="hidden" name="state" value="XX" />
		 <input type="hidden" name="email" value="bill@gmx.net" />
		 <input type="hidden" name="city" value="newyork" />
		 <input type="hidden" name="street_address" value="grana" />
		 <input type="hidden" name="product_id" value="" />
		 <input type="hidden" name="cart_order_id" value="2532" />
		 <input type="hidden" name="tcoid" value="93ec416a4c94c588d8e89fc9ad30dc59" />
		 <input type="hidden" name="country" value="US" />
		 <input type="hidden" name="order_number" value="3550580633" />
		 <input type="hidden" name="merchant_order_id" value="" />
		 <input type="hidden" name="option-" value="" />
		 <input type="hidden" name="cart_id" value="2532" />
		 <input type="hidden" name="Product_description" value="" />
		 <input type="hidden" name="lang" value="" />
		 <input type="hidden" name="demo" value="Y" />
		 <input type="hidden" name="pay_method" value="CC" />
		 <input type="hidden" name="quantity" value="1" />
		 <input type="hidden" name="total" value="39.95" />
		 <input type="hidden" name="phone" value="0917363521" />
		 <input type="hidden" name="return_url" value="" />
		 <input type="hidden" name="credit_card_processed" value="Y" />
		 <input type="hidden" name="zip" value="10000" />
		 <input type="hidden" name="merchant_product_id" value="2532" />
		 <input type="hidden" name="merchant_web_site" value="http%3a%2f%2flocalhost%3a4478%2fcart_web_site" />
		 <input type="hidden" name="card_holder_name" value="bill brown" />
		 <input type="submit" value="Click Here To Finalize Your Order" />
		 </form>

		 * PARAMETERS SENT BACK FROM 2CHECKOUT
			sid: 	 504845
			fixed: 	 Y
			key: 	 A8308D8551A3D60B06AEC434A0F462EA
			state: 	 XX
			email: 	 bill@gmx.net
			city: 	 newyork
			street_address: 	 grana
			product_id: 	 
			cart_order_id: 	 2532
			tcoid: 	 93ec416a4c94c588d8e89fc9ad30dc59
			country: 	 US
			order_number: 	 3550580633
			merchant_order_id: 	 
			option-: 	 
			cart_id: 	 2532
			Product_description: 	 
			lang: 	 
			demo: 	 Y
			pay_method: 	 CC
			quantity: 	 1
			total: 	 39.95
			phone: 	 0917363521
			return_url: 	 
			credit_card_processed: 	 Y
			zip: 	 10000
			merchant_product_id: 	 2532
			merchant_web_site: 	 http%3a%2f%2flocalhost%3a4478%2fcart_web_site
			card_holder_name: 	 bill brown

		 */
		//hiden image:
		//<img src="http://www.imflab.com/Default.aspx?order=2320254052&total=11.66&product=26&quantity=1" />  

		//key = md5 (secret word + vendor number + order number + total);
		// or x_MD5_hash = md5 (secret word + vendor number + order number + total);

		// secret word		= AppSettingsProvider.ReadFromDbOrCache("SecretWord");
		// vendor number	= 504845
		// order_number		= 2314884877
		// total			= 99.95
		// key				= 03672A1FE9885C9AAD49323FA25B4A91

		//read values:
		// order_number
		// total
		// key    (MD5 hash)
		// credit_card_processed  (Y if ok or K if pending)
		// sid   (vendorID)
		// merchant_product_id ( we send it as cart_order_id)
		//string[] keys = Request.Form.AllKeys;
		//string data = "secret word" + "vendor number" + "order number" + "total";

		#endregion

		// REQUIRED KEYS IN POST FROM 2CHECKOUT 
		private static string [] requiredKeys = {"credit_card_processed" , "order_number", "sid",  "key", "merchant_web_site"};

		// ORDER COMPLETE
		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// test received parameters to be sure that web request came from 2checkout
			foreach (string key in requiredKeys)
			{
				if (context.Request.Form[key] == null)
				{
					// request doesn't have all the parameters, request is not valid request
					return null;
				}
			}

			// request came from 2checkout, read all parameters
			PGStatus pgstatus = new PGStatus(base.PaymentType);

			string sVendorNumber = context.Request.Form["sid"] + "";
			string sOrderNumber = context.Request.Form["order_number"] + "";
			string sCardProcessed = context.Request.Form["credit_card_processed"] + "";
			string sTotal = context.Request.Form["total"] + "";
			decimal dTotal = -1;
			decimal.TryParse(sTotal, out dTotal);
			string sKeyHashed = context.Request.Form["key"] + "";
			// merchant_product_id ( we sent it as 'cart_order_id')
			string sCartOrderId = context.Request.Form["cart_order_id"] + "";
			string sTempOrderNo = sOrderNumber;
			if (base.PaymentType.IsDemo == true)
			{
				//in demo mode:
				sTempOrderNo = "1";
				sOrderNumber = "DEMO_" + sOrderNumber;
			}

			int iOrderID = 0;
			int.TryParse(sCartOrderId, out iOrderID);

			//hash is calculated with sTempOrderNumber=1 if DEMO mode activated
			string data = base.PaymentType.MerchantKey + base.PaymentType.MerchantId + sTempOrderNo + sTotal;
			string sKeyCalculated = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(data, "md5");
			//bool bTransactionIsOk = false;

			// final object
			pgstatus.TransactionId = sOrderNumber;
			pgstatus.OrderID = iOrderID;
			pgstatus.TotalPaid = dTotal; // always in USD

			if ((sKeyHashed != "") && (sKeyCalculated == sKeyHashed))
			{
				// response is valid
				pgstatus.IsSignatureOK = true;
			}
			else
			{
				// response is not valid
				pgstatus.IsSignatureOK = false;
			}

			return pgstatus;
		}

#endif
		
	}
}
