﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text.RegularExpressions;

namespace Ice.Net.Ecommerce.PaymentGateways.PG
{
	internal class PGGTPay : BasePG
	{
		public override bool AIMMethod
		{
			get { return false; }
		}
		public override PGNameEnum PGNameEnum
		{
			get { return PGNameEnum._GTPay; }
		}

		public override PGResult GetFormWithParameters(Order order)
		{
			return new PGResult(null, this.GetForm(order), null);
		}

		public override PGStatus GetReceivedStatus(HttpContext context)
		{
			return this.DecodeData(context);
		}
		public override PGResult ChargeAIMMethodWorker(CreditCardInfo ccInfo, Order order)
		{
			return null;
		}

		#region Control Panel HTML

		public override string GetControlPanelHtml()
		{
			return @"

<!--2CHECKOUT CONTROL PANEL-->
<table cellpadding='0px' cellspacing='5px' >
<tr><td >Name</td><td><input type='text' name='Name' style='width:255px;'/></td></tr>
<tr><td >Active</td><td><input type='checkbox' name='IsActive' /></td></tr>

<tr><td >Diagnostic</td><td><input type='checkbox' name='IsDiagnostic' /></td></tr>
<tr><td >Merchant ID</td><td><input name='MerchantId' type='text' style='width:256px;' /></td></tr>



<tr><td >Description<br/></td><td><textarea id='textareaPTDescription'  name='Description' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>
<tr><td >Long Description<br/></td><td><textarea id='textareaPTLongDescription' name='LongDescription' rows='200' cols='2000' style='height:50px;width:255px;'></textarea></td></tr>


<tr><td colspan='2' style='text-align:center; height:20px'><a href='https://gtpay.gtbank.com/public/?' target='_blank'><b> https://gtpay.gtbank.com/ </b></a></td></tr>
<tr><td></td><td><div style='display:none'>

<!--quick help content-->

</div><div align='right'><a href='#' onclick='QoDesk.PaymentTypeEditor.ShowQuickHelp(this);'><b>Quick Help</b></a></div>
</td></tr>
</table>
";

		}

		#endregion


		// USER DEPENDING PARAMETERS
		private static string mTransactionUrl = "https://gtpay.gtbank.com/public/tranx.jsp"; // standard checkout
		//private static string mSPPTransactionUrl = "https://gtpay.gtbplc.com/public/tranx.jsp"; //single page purchase routine

		//string mSiteRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot; // example: http://www.iceasp.net/

		string mSiteRoot = "http://127.0.0.1/vv/";

		//string mGTpayIP = "";

		private string GetAmountToPay(decimal amount) // 
		{
			string strtotal = amount.ToString("n2");
			string dollars = strtotal.Substring(0, strtotal.Length - 3);
			string cents = strtotal.Substring(strtotal.Length - 2);
			dollars = dollars.Replace(",", ""); // remove , if any left
			dollars = dollars.Replace(".", ""); // remove . if any
			strtotal = dollars + "." + cents;
			return strtotal;
		}

		private string GetTransactionURL()
		{
			{
				return mTransactionUrl;
			}
		}

		private string GetForm(Order order)
		{
			return (String.Format("<form method=\"post\" action=\"{0}\">\r\n{1}</form>", GetTransactionURL(), GetTransactionFormBody(order)));
		}

#if TRIAL
		private string GetTransactionFormBody(Order order)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}

		private PGStatus DecodeData(HttpContext context)
		{
			throw new Exception("*********************************\r\nDISABLED IN TRIAL VERSION!\r\n*********************************");
		}
#else

		private string GetTransactionFormBody(Order order)
		{
			NameValuePairCollection nv = new NameValuePairCollection();

			nv.Add("gtpay_mert_id", base.PaymentType.MerchantId);
			nv.Add("gtpay_tranx_curr", BusinessObjects.Common.VISTACARTHelper.AppDefaults.Currency.ISOCode);// currency code USD, EUR...
			nv.Add("gtpay_tranx_amt", GetAmountToPay(order.RedundantTotalToPay));
			nv.Add("gtpay_tranx_id", order.OrderID + "");
			nv.Add("gtpay_cust_id", order.UserID + "");
			nv.Add("gtpay_tranx_noti_url", mSiteRoot + OrderCompletePage);
			//nv.Add("gtpay_echo_data", base.PaymentType.MerchantId);
			nv.Add("gtpay_no_show_cust_id", "yes");// //no = show, whereas yes = dont show
			return nv.ToFormPOSTInputs();
		}

/*
 * redirect from GTPay:
gtpay_cust_id	1
gtpay_gway_name	webpay
gtpay_referer	http://127.0.0.1/vv/?p=checkoutaddress
gtpay_req_session_id	
gtpay_tranx_amt	250.32
gtpay_tranx_curr	USD
gtpay_tranx_id	30
gtpay_tranx_memo	Purchasing from LIVING FAITH FOUNDATION
gtpay_tranx_status_code	x01
gtpay_tranx_status_msg	Transaction could not be authorized. Please contact your bank or send an email to webpay.support@interswitchng.com
 */

		// REQUIRED KEYS IN POST FROM GTPay 
		private static string[] requiredKeys = { "gtpay_tranx_id", "gtpay_tranx_status_code", "gtpay_tranx_curr", "gtpay_tranx_amt" };

		// ORDER COMPLETE
		private PGStatus DecodeData(HttpContext context)
		{
			if (base.PaymentType.IsActive != true)
			{
				return null;
			}

			// test received parameters to be sure that web request came from 2checkout
			foreach (string key in requiredKeys)
			{
				if (context.Request.Form[key] == null)
				{
					// request doesn't have all the parameters, request is not valid request
					return null;
				}
			}

			// request came from 2checkout, read all parameters
			PGStatus pgstatus = new PGStatus(base.PaymentType);

			// the only validation is IP where the request came from (ChronoID)
			//if (context.Request.UserHostAddress == mGTpayIP)
			{

	
				string sTotal = context.Request.Form["gtpay_tranx_amt"] + "";
				decimal dTotal = -1;
				decimal.TryParse(sTotal, out dTotal);

				string sCartOrderId = context.Request.Form["gtpay_tranx_id"] + "";

				int iOrderID = 0;
				int.TryParse(sCartOrderId, out iOrderID);

				// final object
				pgstatus.TransactionId = sCartOrderId;
				pgstatus.OrderID = iOrderID;
				pgstatus.TotalPaid = dTotal;

				string sStatusCode = context.Request.Form["gtpay_tranx_status_code"] + "";
				pgstatus.Description = context.Request.Form["gtpay_tranx_status_msg"] + "";
				
				int statusCode = 0;
				if (int.TryParse(sStatusCode, out statusCode) && statusCode == 0 && iOrderID > 0)
				{
					pgstatus.IsSignatureOK = true; // status code is 0, successful
				}
				else
				{
					pgstatus.IsSignatureOK = false;
				}
			}

			return pgstatus;
		}

#endif
	}
}
