﻿using System;
using System.Data;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Data.SqlClient;
using System.Web;
using Ice.Net.Ecommerce.PaymentGateways.PG;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Collections;
using Ice.Net.Ecommerce.OrderContentForEmail;

namespace Ice.Net.Ecommerce.PaymentGateways
{
	public class UtilityHelper
	{
		#region Order complete handling

		private static Object mCallbackLock = new Object();

		public static void OrderComplete()
		{
#if !TRIAL
			Order order = null;
			lock (mCallbackLock)
			{
				order = PGHelper.ValidatePGCallback(HttpContext.Current); // confirmation email is sent from PGSelector class!!!
			}

			if (order != null && order.OrderID > 0)
			{
				// valid data received from PG
				string url = "default.aspx?p=" + Category.Shortcut.ordercomplete + "&oid=" + order.OrderID;
				HttpContext.Current.Server.Transfer(BusinessObjects.Common.ApplicationUtility.SkinDirectory + url);
			}
			else
			{
				// invalid data received
				HttpContext.Current.Server.Transfer(BusinessObjects.Common.ApplicationUtility.SkinDirectory + "default.aspx");
			}
#endif
		}

		#endregion

		#region Save diagnostic

		public static void SaveDiagnostic(string gatewayName, string text)
		{
			WriteLog(HttpContext.Current, gatewayName, text + "\r\n");
		}

		// catch data from payment gateway
		public static void SaveDiagnostic(string gatewayName, HttpContext context)
		{

			string vals = "";
			vals += "\r\n";

			vals += "Received: \t " + DateTime.Now + "\r\n\r\n";

			vals += "GET: " + context.Request.QueryString + "\r\n\r\n";

			vals += "FORM: " + context.Request.Form + "\r\n\r\n";

			vals += "\r\n\r\nGET KEYS\r\n";

			string[] keys = context.Request.QueryString.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + context.Request.QueryString[key] + "\r\n";
			}


			vals += "\r\n\r\nFROM KEYS\r\n";

			keys = context.Request.Form.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + context.Request.Form[key] + "\r\n";
			}

			vals += "\r\n\r\n\r\n";

			vals += "User host IP: \t " + context.Request.UserHostAddress;

			vals += "\r\n\r\n\r\n";

			vals += "Referer: \t " + context.Request.UrlReferrer;

			vals += "\r\n\r\n\r\n";

			vals += "UserAgent: \t " + context.Request.UserAgent;


			vals += "\r\n\r\n\r\n";

			vals += "======= ServerVariables ======= \r\n";
			keys = context.Request.ServerVariables.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + context.Request.ServerVariables[key] + "\r\n";
			}


			vals += "\r\n\r\n\r\n";

			vals += "========= Headers ======= \r\n";
			keys = context.Request.Headers.AllKeys;
			foreach (string key in keys)
			{
				vals += key + ": \t " + context.Request.Headers[key] + "\r\n";
			}

			vals += "\r\n\r\n\r\n";

			WriteLog(context, gatewayName, vals);

		}

		private static void WriteLog(HttpContext context, string gatewayName, string text)
		{
			System.IO.StreamWriter fs = null;
			try
			{
				string filePath = context.Request.PhysicalApplicationPath + "App_Data\\Log\\" + DateTime.Now.Ticks + "_" + gatewayName + ".txt";
				fs = new System.IO.StreamWriter(filePath);
				fs.Write(text);
			}
			catch
			{
			}
			finally
			{
				if (fs != null)
				{
					fs.Flush();
					fs.Close();
				}

			}
		}

		#endregion

	}
}
