﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Web.Services;
using System.Collections.Generic;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Web;

namespace Ice.Net.Ecommerce.Web.Admin.VISTACART
{

	public partial class Default : System.Web.UI.Page
	{
		protected string extDir = "Ext_21";
		protected string mAppRoot = "";
		protected string mUsername = "";
		protected int mPagerPageSize = 0;
		protected string mCurrencyISOCode = "";
		protected string mWeightUnitSymbol = "";
		bool mIsDebugVersion = false;
		protected string mCurrentJsLanguage = "en-US"; // default language

		protected void Page_Load(object sender, EventArgs e)
		{

			////IceHttpCompressionFilter.AddCompressionFilter(HttpContext.Current);

			Response.Cache.SetNoStore();

			
#if DEBUG
			mIsDebugVersion = true;
#endif

			// LANGUAGE TO USE
			if (System.IO.File.Exists(Request.PhysicalApplicationPath + "Admin\\VISTACART\\res\\js\\language\\" + System.Globalization.CultureInfo.CurrentCulture.Name + ".js"))
			{
				mCurrentJsLanguage = System.Globalization.CultureInfo.CurrentCulture.Name;
			}
			IceScriptManagerMain.Scripts += "\r\n" + "res/js/language/" + mCurrentJsLanguage + ".js" + "\r\n";

			divReadOnlyMode.Visible = new AppGlobalSetting().GetDataStore().DbSetting.DisableWrite;

			// STANDARD REQUEST
			mAppRoot = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRootCurrent;
			mPagerPageSize = VISTACARTHelper.AppDefaults.PagerSize.Size;
			mCurrencyISOCode = VISTACARTHelper.AppDefaults.Currency.ISOCode;
			mWeightUnitSymbol = VISTACARTHelper.AppDefaults.WeightUnit.Symbol;

			CommonUtility.UpdateStatuses(true);

			// if user not authenticated, redirect to login.aspx
			User user = new User();
			if (VISTACARTHelper.CurrentUser.AdminTicket.IsAuthenticated
				&& user.LoadFromDB(VISTACARTHelper.CurrentUser.AdminTicket.UserID)
				&& user.IsActive
				&& user.IsInRole(Role.NameEnum.Administrators))
			{
				// ok
				mUsername = VISTACARTHelper.CurrentUser.AdminTicket.Username;
				plcAuthenticated.Visible = true;
				plcNotAuthenticated.Visible = false;
			}
			else if (BusinessObjects.Common.OnlineDemoSkinHelper.IsOnlineDemoAdmin && VISTACARTHelper.CurrentUser.AdminTicket.IsAuthenticated)
			{
				mUsername = VISTACARTHelper.CurrentUser.AdminTicket.Username;
				plcAuthenticated.Visible = true;
				plcNotAuthenticated.Visible = false;
			}
			else
			{
				//Response.Redirect("Login.aspx");
				plcAuthenticated.Visible = false;
				plcNotAuthenticated.Visible = true;
			}


		}

	}
}
