﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text;

namespace Ice.Net.Ecommerce.Web.Modules
{
	public partial class Checkout_1_1 : System.Web.UI.UserControl
	{
		protected string mShoppingCart = "";
		protected string mUrl = "";

		protected string mCountries = "";
		protected string mStates = "";
		protected string mForward = Message.GetContent(Message.NameEnum.Forward);
		protected string mBack = Message.GetContent(Message.NameEnum.Back);

		protected void Page_Load(object sender, EventArgs e)
		{
			ForceRender();
		}

		private void ForceRender()
		{
			/////////////////////////////////////////////////////////////////
			// SSL IS REQUIRED IF USING API PAYMENT METHOD
			/////////////////////////////////////////////////////////////////

			mUrl = SSLModeUtility.GetRedirectUrlIfRequired();
			if(mUrl != null)
			{
				plcContent.Visible = false;
				plcSSLRedirect.Visible = true;
				return; // stop processing the code
			}


			if (VISTACARTHelper.CurrentUser.UserTicket.IsAuthenticated)
			{
				divAccountCreation.Visible = false;
			}
			else
			{
			}

			ShoppingCart cart = VISTACARTHelper.CurrentUser.ShoppingCart;
			if (cart.Order.RedundantTotalProductsCount == 0)
			{
				plcSSLRedirect.Visible = true;
				// redirect to homepage
				mUrl = "./";
				return;
			}

			if (VISTACARTHelper.CurrentUser.UserTicket.IsAuthenticated)
			{
				cart.CreateBillingAndShippingAddresses(); // if not already made, make 2 copies of existing Address for billing Address and shipping Address
			}

			mCountries = HtmlElements.CountriesHtmlBuilder.GetHtml(VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.CountryID);
			mStates = HtmlElements.StatesHtmlBuilder.GetHtml(VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.StateID);

		}

		private string GetAddress(int addressID)
		{
			return Ice.Net.Ecommerce.OrderContentForEmail.AddressBuilder.GetHtml(addressID);
		}

	}
}
