﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text;

namespace Ice.Net.Ecommerce.Web.Modules
{
	public partial class Checkout_2_1 : System.Web.UI.UserControl
	{
		protected string mShoppingCart = "";
		protected string mBillingAddress = "";
		protected string mShippingAddress = "";
		protected string mPaymentTypeLongDesc = "";
		protected string mUrl = "";
		protected string mForward = Message.GetContent(Message.NameEnum.Forward);
		protected string mBack = Message.GetContent(Message.NameEnum.Back);

		protected void Page_Load(object sender, EventArgs e)
		{
			ForceRender();
		}

		private void ForceRender()
		{
			/////////////////////////////////////////////////////////////////
			// SSL IS REQUIRED IF USING API PAYMENT METHOD
			/////////////////////////////////////////////////////////////////
			mUrl = SSLModeUtility.GetRedirectUrlIfRequired();

			if (mUrl != null)
			{
				plcContent.Visible = false;
				plcSSLRedirect.Visible = true;
				return; // stop processing the code
			}

			if (VISTACARTHelper.CurrentUser.UserTicket.IsAuthenticated)
			{
				ShoppingCart cart = VISTACARTHelper.CurrentUser.ShoppingCart;
				if (cart.Order.RedundantTotalProductsCount == 0 || cart.Order.OrderStatus != Order.OrderStatusEnum.ShoppingCart)
				{
					mUrl = "./";
					plcSSLRedirect.Visible = true;
					plcContent.Visible = false;
				}

				cart.CreateBillingAndShippingAddresses(); // if not already made, make 2 copies of existing Address for billing Address and shipping Address

				PaymentType pt = new PaymentType();
				pt.LoadFromDB(cart.Order.PaymentTypeID);
				mPaymentTypeLongDesc = pt.LongDescription;

				mShoppingCart = Modules.HtmlElements.ShoppingCartHtmlBuilder.GetHtml(cart.Order, false);
				mBillingAddress = GetAddress(cart.Order.BillingAddressID);
				mShippingAddress = GetAddress(cart.Order.ShippingAddressID);
			}
			else
			{
				mUrl = "./";
				plcSSLRedirect.Visible = true;
				plcContent.Visible = false;
			}
		}

		private string GetAddress(int? addressID)
		{
			return Ice.Net.Ecommerce.OrderContentForEmail.AddressBuilder.GetHtml(addressID);
		}

	}
}
