﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Text;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Collections.Generic;

namespace Ice.Net.Ecommerce.Web.Modules
{
	public partial class CurrencySelector : System.Web.UI.UserControl
	{
		protected string mOptions = "";

		protected void Page_Load(object sender, EventArgs e)
		{
			if (Page.IsPostBack)
			{

			}
			else
			{
				// currencies selector, get from cache first
				string currencyCacheKey = "currSel_" + VISTACARTHelper.CurrentUser.UserInfo.CurrencyID + "_" + VISTACARTHelper.CurrentUser.UserInfo.LanguageID;
				Object oCurrencySelector = HttpContext.Current.Cache[currencyCacheKey];
				if (oCurrencySelector != null)
				{
					mOptions = (String)oCurrencySelector;
				}
				else
				{
					mOptions = GetCurrencySelectHtml(VISTACARTHelper.CurrentUser.UserInfo.CurrencyID);
					HttpContext.Current.Cache.Insert(currencyCacheKey, mOptions);
				}
			}
		}

		private string GetCurrencySelectHtml(int selectedCurrencyID)
		{
			StringBuilder sb = new StringBuilder();
			List<Currency> currencies = SmartObjectLoader.LoadCollection<Currency>(1000, true, db.Currency.Ordinal, false);

			foreach (Currency currency in currencies)
			{
				string selected = "";
				if (currency.CurrencyID == selectedCurrencyID)
				{
					selected = " selected='selected'";
				}

				sb.Append(@"
<option value='" + currency.CurrencyID + "'" + selected + ">" + currency.ISOCode + " - " + currency.Name + "</option>");
			}

			return sb.ToString();
		}
	}
}