﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;
using System.Text;
using Ice.Net.Ecommerce.Web.WebService;

namespace Ice.Net.Ecommerce.Web.Modules
{

	public partial class OnlineDemoSkinSelector : System.Web.UI.UserControl
	{
		protected string mOptions;

		protected void Page_Load(object sender, EventArgs e)
		{
			this.Visible = System.Configuration.ConfigurationManager.AppSettings["OnlineDemo"] == "true";
			if (this.Visible != true)
			{
				return;
			}
			
			mOptions = GetSkinDirectorySelectHtml();
		}


		private string GetSkinDirectorySelectHtml()
		{
			string skinRoot = HttpContext.Current.Request.PhysicalApplicationPath + System.Configuration.ConfigurationManager.AppSettings["SkinsRoot"].Trim('/');
			StringBuilder sb = new StringBuilder();
			string currentSkinDirectory = BusinessObjects.Common.OnlineDemoSkinHelper.GetCurrentSkinDirectory();

			// load child direcotries
			string[] childDirectories = System.IO.Directory.GetDirectories(skinRoot);
			foreach (string directory in childDirectories)
			{
				string dirName = GetNameOnly(directory);
				string selected = "";
				if (currentSkinDirectory == dirName)
				{
					selected = " selected='selected'";
				}
				sb.Append(@"
<option value='" + dirName + "'" + selected + ">" + dirName + "</option>");

			}
			return sb.ToString();
		}

		private string GetNameOnly(string fullPath)
		{
			string nameOnly = fullPath.Substring(fullPath.LastIndexOf("\\") + 1);
			return nameOnly;
		}


	}
}