﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using System.Text;
using Ice.Net.Ecommerce.Web.Modules.HtmlElements;
using Ice.Net.Ecommerce.Web.Modules.Common;
using System.Collections.Generic;
using System.Linq;

namespace Ice.Net.Ecommerce.Web.Skins.CarSpares
{
	public partial class masterSite : System.Web.UI.MasterPage
	{
		protected string mBase = "";
		protected string mCategoriesMenu = "";
		protected string mNavigationMap = "";

		protected string mMetaTitle = "";
		protected string mMetaKeywords = "";
		protected string mMetaDescription = "";

		protected string mUsername = "";
		protected int mCartCount = 0;
		protected string mCartTotalToPay = "";
		protected string mCurrencyISOCode = "";
		protected string mSearchExpression = "";
		private int mRootCategoryID = VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.RootCategoryID.GetValueOrDefault();
		protected string mLanguageDir = "english";
		protected string mCategories = Message.GetContent(Message.NameEnum.Categories);
		protected string mLanguageTxt = Message.GetContent(Message.NameEnum.Language);
		protected string mCurrency = Message.GetContent(Message.NameEnum.Currency);
		protected string mSearch = Message.GetContent(Message.NameEnum.Search);
		protected string mShoppingCart = Message.GetContent(Message.NameEnum.ShoppingCart);

		

		protected void Page_Load(object sender, EventArgs e)
		{

			mBase = BusinessObjects.Common.ApplicationUtility.ApplicationHttpRoot;

			if (Page.IsPostBack)
			{

			}
			else
			{
				string skinDir = BusinessObjects.Common.ApplicationUtility.SkinDirectoryRelative;
				languageCss.Href = skinDir + "css/" + mLanguageDir + ".css";
				defaultCss.Href = skinDir + defaultCss.Href;
				stylesheetCss.Href = skinDir + stylesheetCss.Href;

				// get categories
				FrontParameters fp = new FrontParameters(Request);
				mSearchExpression = fp.SearchExpression;

				Category cat;
				if (fp.Kind == FrontParameters.KindEnum.CategoryShortcut && (cat = Category.LoadByShortcutName(fp.CategoryShortcutName)) != null)
				{
					fp.CategoryID = cat.CategoryID;
					fp.LinkName = cat.Name;
				}

				int clickedCategoryID = fp.CategoryID;
				if (clickedCategoryID == 0)
				{
					clickedCategoryID = mRootCategoryID;
				}

				// load navigation map
				plcNavigationMap.Controls.Add(new LiteralControl(RequestHelper.Current.GetNavigationMap(" | ", false)));

				// create page meta tags
				CreateMetaInfo(fp);

				// load categories menu
				mCategoriesMenu = GetCategoriesMenu(clickedCategoryID);

				// currency iso code
				mCurrencyISOCode = VISTACARTHelper.CurrentUser.Currency.ISOCode;

				// login panel
				if (VISTACARTHelper.CurrentUser.UserTicket.IsAuthenticated)
				{
					mUsername = VISTACARTHelper.CurrentUser.UserTicket.Username;
					//divLoginForm.Visible = false;
					//divLoginInfo.Visible = true;
				}

				// shopping cart data
				ShoppingCart cart = VISTACARTHelper.CurrentUser.ShoppingCart;
				mCartCount = cart.Order.RedundantTotalProductsCount;
				mCartTotalToPay = CurrencyUtility.ConvertPrice(cart.Order.RedundantTotalToPay).ToString("n2");

			}
		}

		private void CreateMetaInfo(FrontParameters fp)
		{
			Modules.Common.PageMetaInfo pminfo = RequestHelper.Current.PageMetaInfo;

			mMetaKeywords = "<meta name=\"keywords\" content=\"" + pminfo.Keywords + "\" />";
			mMetaDescription = "<meta name=\"description\" content=\"" + pminfo.Description + "\" />";

			if (pminfo.Title.Length > 0)
			{
				mMetaTitle = pminfo.Title + " - ";
			}
		}

		#region CATEGORIES TREE MENU

		private string GetCategoriesMenu(int clickedCategoryID)
		{
			// always show first level categories
			FrontParameters fp = new FrontParameters();
			CategoryCollection chain = new CategoryCollection();
			chain.LoadCategoriesChain(clickedCategoryID, VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.RootCategoryID, true);

			List<Category>categories = CategoryCollection.LoadByParentCategoryID(chain[0].CategoryID, true, false);
			return GetMenu(chain, categories, fp, clickedCategoryID, 0);
		}

		private string GetMenu(List<Category> chain, List<Category> categories, FrontParameters fp, int clickedCategoryID, int level)
		{
			int addedCategories = 0;

			if (categories.Count == 0)
			{
				return "";
			}

			System.Text.StringBuilder sb = new System.Text.StringBuilder();

			foreach (Category cat in categories)
			{
				if (cat.IsInTree != true || cat.IsPublished != true)
				{
					continue;
				}
				addedCategories++;

				string cls = "";
				bool subcategories = false;
				if (chain.Any(o=>o.CategoryID == cat.CategoryID))
				{
					subcategories = true;
					cls = " class=\"current\"";
				}
				fp.CategoryID = cat.CategoryID;
				if (VISTACARTHelper.AppDefaults.AppGlobalSettingsItem.IsNameInURL.GetValueOrDefault())
				{
					fp.LinkName = cat.Name;
				}
				else
				{
					fp.LinkName = "";
				}
				sb.Append(String.Format(@"<li class='bg_list'>{3}<font><a{2} href='{0}'>{1}</a></font>{4}</li>",
	fp.RelativeLink,
	cat.Name,
	cls,
	GetDivs(level, true),
	GetDivs(level, false)
		));

				// add subcategories
				if (subcategories)
				{
					List<Category> children = CategoryCollection.LoadByParentCategoryID(cat.CategoryID, true, false);
					sb.Append(GetMenu(chain, children, fp, clickedCategoryID, level + 1));
				}

			}

			if (addedCategories == 0)
			{
				return "";
			}

			return sb.ToString();
		}

		private string GetDivs(int level, bool opening)
		{
			string divs = "";
			for (int n = 0; n < level; n++)
			{
				if (opening)
				{
					divs += "<div>";
				}
				else
				{
					divs += "</div>";
				}
			}
			return divs;
		}

		#endregion

	}


}
