﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using Ice.Net.Ecommerce.Web.Modules.Common;
using System.Collections.Generic;

namespace Ice.Net.Ecommerce.Web.Skins.Imaging
{
	public partial class ProductsList : System.Web.UI.UserControl
	{
		protected string mLanguageDir = "english";
		protected string mWebPageContent = "";
		protected string mProductsList = "";
		protected int mCurrentPagerPage;
		protected int mPagesTotal;
		protected string mPagerRewLink = "";
		protected string mPagerFFLink = "";
		protected string mNavigationMap = "";
		protected string mPagerLinks = "";

		private ProductsPager mProductsPager = null;
		public ProductsPager ProductsPager
		{
			get { return mProductsPager; }
			set { mProductsPager = value; }
		}

		protected void Page_Load(object sender, EventArgs e)
		{
			if (this.Visible == false)
			{
				return;
			}

			if (Page.IsPostBack)
			{
			}
			else
			{
				RequestHelper rh = RequestHelper.Current;

				ProductsPager ppager = mProductsPager == null ? rh.ProductsPager : mProductsPager;

				if (ppager.ProductDataCollection.Count == 0)
				{
					this.Visible = false;
					return;
				}

				plcProductsList.Controls.Add(new LiteralControl(GetProductsHtml(ppager.ProductDataCollection)));
				plcPagerTop.Controls.Add(new LiteralControl(GetPagerHtml(ppager)));
				plcPagerBottom.Controls.Add(new LiteralControl(GetPagerHtml(ppager)));

				mCurrentPagerPage = rh.ProductsPager.CurrentPage;
				mPagesTotal = rh.ProductsPager.TotalPages;
				mPagerRewLink = rh.ProductsPager.PreviousPageLink;
				mPagerFFLink = rh.ProductsPager.NextPageLink;

			}

		}

		#region PAGER HTML

		private string GetPagerHtml(ProductsPager pager)
		{
			if (pager.ProductCollection == null || pager.ProductCollection.Count == 0 || pager.TotalPages < 2)
			{
				return "";
			}

			return String.Format(@"	
<table width='100%' cellspacing='0' cellpadding='0' border='0' class='result'>
  <tbody><tr>
    <td>Page <b>{0}</b> of <b>{1}</b>&nbsp;&nbsp;&nbsp;<a href='{2}'>&lt;&lt;</a>&nbsp;&nbsp;&nbsp;<a href='{3}'>&gt;&gt;</a></td>
  </tr>
</tbody></table>
",
 pager.CurrentPage,
 pager.TotalPages,
 pager.PreviousPageLink,
 pager.NextPageLink
 );

		}

		#endregion

		#region PRODUCTS HTML

		private string GetProductsHtml(ProductDataCollection pdatacollection)
		{

			if (pdatacollection == null || pdatacollection.Count == 0)
			{
				return "";
			}

			// create products listing
			int prodsInRow = 0;
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append("<table border='0' width='' cellspacing='0' cellpadding='0'>");

			foreach (ProductData pd in pdatacollection)
			{
				prodsInRow++;

				if ((prodsInRow - 1) % 2 == 0)
				{
					// start new row
					sb.Append(@"
<tr>");
				}

				// single product holder + single product html
				sb.Append(String.Format(@"
<td align='center' style='width: 50%;'>
{0}</td>",
		 GetSingleProductHtml(pd)));

				if (prodsInRow % 2 != 0)
				{
					// add vertical spacer
					sb.Append(@"
<td class='prod_line_y padd_vv'><img width='1' height='1' border='0' alt='' src='images/spacer.gif.htm'/></td>");
				}

				//  if this is the last product in the collection but count % 3 != 0, add empty products to have 3 td in tr row
				if (prodsInRow == pdatacollection.Count)
				{
					for (int n = 0; n < (2 - pdatacollection.Count % 2); n++)
					{
						sb.Append(String.Format(@"<td align='center' style='width: 50%;'></td>"));

						if (prodsInRow % 2 != 0)
						{
							// add vertical spacer
							sb.Append(@"<td></td>");

						}

						prodsInRow++;
					}
				}

				if (prodsInRow % 2 == 0)
				{
					// row end
					sb.Append(@"
</tr>");
					// horizontal spacer
					sb.Append(@"
<tr><td class='prod_line_x padd_gg' colspan='3'><img width='1' height='1' border='0' src='images/spacer.gif.htm' alt=''/></td></tr>
					 ");
				}

			}

			// table end
			sb.Append("</table>");

			return sb.ToString();
		}

		private string GetSingleProductHtml(ProductData pd)
		{

			string html = String.Format(@"
<table cellspacing='0' cellpadding='0' border='0'><tbody><tr><td style='padding: 0px;'>
		<table cellspacing='0' cellpadding='0' border='0' class='name_pad_table'>
			<tbody><tr><td class='name name_padd'><a href='{0}'>{2}</a></td></tr>
		</tbody></table>
		<table cellspacing='0' cellpadding='0' border='0' style='margin: 11px 0px;'>
			<tbody><tr>
			  <td><div class='p_t'>
					<div class='p_r'>
						<div class='p_b'>
							<div class='p_l'>
								<div class='p_tl'>
									<div class='p_tr'>
										<div class='p_bl'>
											<div class='p_br'>
												<div class='width_100'><div class='imageContainer loadingMask' onclick='window.location=""{0}""'><img class='imageLoader' src='{1}' border='0' alt='{2}' title='{2}' /></div></div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div></td>
			  <td style='padding: 0px 0px 0px 11px; width: 100%;'>
					<table cellspacing='0' cellpadding='0' border='0'>
						<tbody><tr><td class='desc desc_padd'>{10}</td></tr>
						<tr><td class='price_padd vam'><span class='productSpecialPrice'><s style='white-space:nowrap;'>{3}</s><br/><span style='white-space:nowrap;'>{4}</span></span></td></tr>
					</tbody></table>
			  </td>
			</tr>
		</tbody></table>
		<table cellspacing='7' cellpadding='0' border='0' style='background: transparent url(images/line_yyy.gif) repeat-x scroll 0px 0px; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
			<tbody><tr><td class='button_padd button_marg vam'>
<a class='buttonDetails' href='{0}'>&nbsp;</a></td><td style='background: transparent url(images/line_yyy.gif) repeat-y scroll 0px 0px; width: 1px; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'><img width='1' height='1' border='0' alt='' src='images/spacer.gif.htm'/>
</td><td class='button_padd button_marg vam'><a class='buttonAddToCart' style='{12}' href='./' onclick='{11}'>&nbsp;</a></td></tr>
		</tbody></table>
		</td></tr></tbody></table>
	",
		pd.DetailsLink,
		 pd.SmallImageLink,
		 pd.Name,
		 pd.OriginalPriceStr,
		 pd.CurrentPriceStr,
		 pd.Product.SKU,
		 GetManufacturerLink(pd.Product.GetManufacturer()),
		 pd.Product.GetManufacturer().Name,
		 pd.Product.StockQuantity,
		pd.Product.Weight,
		GetShortDescription(pd.Product),
		"Ice.GCart.AddProductToCart(" + pd.Product.ProductID + "); return false;",
		pd.Product.StockQuantity > 0 ? "" : "display:none"
	 );
			return html;
		
		

		}

		private string GetSingleProductHtml2(ProductData pd)
		{

			string html = String.Format(@"
    <table cellpadding='0' cellspacing='0' border='0'><tr><td style='padding:3px 10px 7px 10px;'>
    
		<table border='0' cellspacing='0' cellpadding='0'>
			<tr><td><table cellpadding='0' cellspacing='0' border='0' align='center' style='width:1px;'><tr><td><div class='imageContainer loadingMask' onclick='window.location=""{0}""'><img class='imageLoader' src='{1}' border='0' alt='{2}' title='{2}' ></div></td></tr></table></td></tr>
			<tr><td class='name name2_padd'><a href='{0}'>{2}</a></td></tr>
			<tr><td class='desc desc2_padd'>{10}</td></tr>
		</table>
" +
@"
		<table border='0' cellspacing='0' cellpadding='0'>
			<tr><td colspan='2' class='price2_padd vam noWrap'><s>{3}</s>&nbsp;&nbsp;<span class='productSpecialPrice'>{4}</span></td></tr>
			<tr><td align='left' class='noWrap'><a class='buttonDetails' href='{0}'>&nbsp;</a></td>
					<td align='right'><a class='buttonAddToCart' style='{12}' href='./' onclick='{11}'>&nbsp;</a></td></tr>
		</table>
		
		</td></tr></table>
		
		",
		 pd.DetailsLink,
		 pd.SmallImageLink,
		 pd.Name,
		 pd.OriginalPriceStr,
		 pd.CurrentPriceStr,
		 pd.Product.SKU,
		 GetManufacturerLink(pd.Product.GetManufacturer()),
		 pd.Product.GetManufacturer().Name,
		 pd.Product.StockQuantity,
		pd.Product.Weight,
		GetShortDescription(pd.Product),
		"Ice.GCart.AddProductToCart(" + pd.Product.ProductID + "); return false;",
		pd.Product.StockQuantity > 0 ? "" : "display:none"
		 );

			return html;

		}

		private string GetShortDescription(Product product)
		{
			//if(product.ShortDescription.Length == 0)
			//{
			//    return CommonUtility.GetTextInLength(product.LongDescription, 50);
			//}
			//else
			{
				return CommonUtility.GetTextInLength(product.ShortDescription, 50);
			}
		}

		private string GetManufacturerLink(Manufacturer manufacturer)
		{
			FrontParameters fp = new FrontParameters();
			fp.ManufacturerID = manufacturer.ManufacturerID;
			return fp.RelativeLink;
		}

		#endregion


	}
}