﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Ice.Net.Ecommerce.BusinessObjects.Common;
using Ice.Net.Ecommerce.BusinessObjects.Database.VISTACART;
using Ice.Net.Ecommerce.Web.Modules.Common;
using System.Collections.Generic;

namespace Ice.Net.Ecommerce.Web.Skins.MobilStore
{
	public partial class ProductsList : System.Web.UI.UserControl
	{

		protected string mWebPageContent = "";
		protected string mProductsList = "";
		protected int mCurrentPagerPage;
		protected int mPagesTotal;
		protected string mPagerRewLink = "";
		protected string mPagerFFLink = "";
		protected string mNavigationMap = "";
		protected string mPagerLinks = "";

		private ProductsPager mProductsPager = null;
		public ProductsPager ProductsPager
		{
			get { return mProductsPager; }
			set { mProductsPager = value; }
		}

		protected void Page_Load(object sender, EventArgs e)
		{
			if (this.Visible == false)
			{
				return;
			}

			if (Page.IsPostBack)
			{
			}
			else
			{

				RequestHelper rh = RequestHelper.Current;

				ProductsPager ppager = mProductsPager == null ? rh.ProductsPager : mProductsPager;

				if (ppager.ProductDataCollection.Count == 0)
				{
					this.Visible = false;
					return;
				}

				plcProductsList.Controls.Add(new LiteralControl(GetProductsHtml(ppager.ProductDataCollection)));
				plcPagerTop.Controls.Add(new LiteralControl(GetPagerHtml(ppager)));
				plcPagerBottom.Controls.Add(new LiteralControl(GetPagerHtml(ppager)));

				mCurrentPagerPage = rh.ProductsPager.CurrentPage;
				mPagesTotal = rh.ProductsPager.TotalPages;
				mPagerRewLink = rh.ProductsPager.PreviousPageLink;
				mPagerFFLink = rh.ProductsPager.NextPageLink;

			}

		}
		
		#region PAGER HTML

		private string GetPagerHtml(ProductsPager pager)
		{
			if (pager.ProductCollection == null || pager.ProductCollection.Count == 0 || pager.TotalPages < 2)
			{
				return "";
			}

			return String.Format(@"	
<table width='100%' cellspacing='0' cellpadding='0' border='0' class='result'>
  <tbody><tr>
    <td>Page <b>{0}</b> of <b>{1}</b>&nbsp;&nbsp;&nbsp;<a href='{2}'>&lt;&lt;</a>&nbsp;&nbsp;&nbsp;<a href='{3}'>&gt;&gt;</a></td>
  </tr>
</tbody></table>
",
 pager.CurrentPage,
 pager.TotalPages,
 pager.PreviousPageLink,
 pager.NextPageLink
 );

		}

		#endregion

		#region PRODUCTS HTML

		private string GetProductsHtml(ProductDataCollection pdatacollection)
		{

			if (pdatacollection == null || pdatacollection.Count == 0)
			{
				return "";
			}

			// create products listing
			int prodsInRow = 0;
			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append(@"<table width='' cellspacing='0' cellpadding='0' border='0' class='box_width_cont product'>
   <tbody><tr>
    <td><table width='' cellspacing='0' cellpadding='0' border='0' class='tableBox_output'>
   <tbody>");


			foreach (ProductData pd in pdatacollection)
			{
				prodsInRow++;

				if ((prodsInRow - 1) % 2 == 0)
				{
					// start new row
					sb.Append(@"
<tr>");
				}

				// single product holder + single product html
				sb.Append(String.Format(@"
<td align='center' style='width: 50%;'>
{0}</td>",
		 GetSingleProductHtml(pd)));

				if (prodsInRow % 2 != 0)
				{
					// add vertical spacer
                    sb.Append(@"
<td class='prod_line_y padd_vv'><img src='images/spacer.gif.htm' border='0' alt='' width='1' height='1'></td>
");

				}

				//  if this is the last product in the collection but count % 3 != 0, add empty products to have 3 td in tr row
				if (prodsInRow == pdatacollection.Count)
				{
					for (int n = 0; n < (3 - pdatacollection.Count % 2); n++)
					{
						sb.Append(String.Format(@"<td align='center'  style='width:50%;'></td>"));

						if (prodsInRow % 2 != 0)
						{
							// add vertical spacer
							sb.Append(@"<td></td>");

						}

						prodsInRow++;
					}
				}

				if (prodsInRow % 2 == 0)
				{
					// row end
					sb.Append(@"
</tr>");
					sb.Append(@"
<tr><td colspan='3' class='bg_line_x padd_gg'><img width='1' height='1' border='0' alt='' src='images/spacer.gif'/></td></tr>
					 ");
				}

			}

			// table end
			sb.Append("</tbody></table>");
			sb.Append("</td></tr></tbody></table>");

			return sb.ToString();
		}


		private string GetSingleProductHtml(ProductData pd)
		{

			string html = String.Format(@"
						
		<table style='background: rgb(255, 255, 255) url(skins/mobilstore/images/side.gif) repeat-x scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; margin-bottom: 6px;'>
              <tbody><tr>
                <td style='background: transparent url(skins/mobilstore/images/side.gif) repeat-x scroll left bottom; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
                  <table style='background: transparent url(skins/mobilstore/images/side.gif) repeat-y scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                    <tbody><tr>
                      <td style='background: transparent url(skins/mobilstore/images/side.gif) repeat-y scroll right bottom; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
                        <table style='background: transparent url(skins/mobilstore/images/ltc.gif) no-repeat scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                          <tbody><tr>
                            <td style='background: transparent url(skins/mobilstore/images/rtc.gif) no-repeat scroll right top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                              <table style='background: transparent url(skins/mobilstore/images/lbc.gif) no-repeat scroll left bottom; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                                <tbody><tr>
                                  <td style='padding: 6px; background: transparent url(skins/mobilstore/images/rbc.gif) no-repeat scroll right bottom; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>


						
										   
										   
						<table style='height: 38px;'>
						  <tbody><tr>
							<td style='height: 53px;'>
							
								
								
			
			
										 
	<table style='background: rgb(242, 242, 242) url(skins/mobilstore/images/title_prod_top.gif) repeat-x scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
		<tbody><tr>
			<td style='background: transparent url(skins/mobilstore/images/title_prod_bottom.gif) repeat-x scroll left bottom; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
					  <table style='background: transparent url(skins/mobilstore/images/ltc2.gif) no-repeat scroll left top; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
						<tbody><tr>
						  <td style='background: transparent url(skins/mobilstore/images/lbc2.gif) no-repeat scroll left bottom; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
							<table style='background: transparent url(skins/mobilstore/images/rtc2.gif) no-repeat scroll right top; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
							  <tbody><tr>
								<td style='background: transparent url(skins/mobilstore/images/rbc2.gif) no-repeat scroll right bottom; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
								  <table style='width: 100%;'>
									<tbody><tr>
									  <td style='padding: 11px 5px 11px 41px; height: 38px;' class='prod_name'>
										
										
										
										
										
										
  <a href='{0}'>{2}</a>
									</td></tr>
								  </tbody></table>
								</td>
							  </tr>
							</tbody></table>
						  </td>
						</tr>
					  </tbody></table>
        </td>
    </tr>
</tbody></table>
										 
   
   
   
   
							
							
							</td>
						  </tr>
						</tbody></table>
						<table style='height: 121px; width: 95%;'>
						  <tbody><tr>
							<td style='width: 110px;'>
								
  
                                    
						  
						  
						  <div class='imageContainer loadingMask' onclick='window.location=""{0}""'><img class='imageLoader' src='{1}' border='0' alt='{2}' title='{2}' ></div>
		
   
							</td>
							<td class='description'>
								<div style='height: 25px;'></div>
{10}
<br/>
<br/>

</td>
						  </tr>
						</tbody></table>
						<table>
											<tbody><tr>
												<td style='margin: 5px; padding: 12px;'>
													       
												</td>
											</tr>
						</tbody></table>
						<table style='height: 48px;'>
						  <tbody><tr>
							<td>
								
						
		<table style='background: rgb(255, 255, 255) url(skins/mobilstore/images/side.gif) repeat-x scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; margin-bottom: 0pt;'>
              <tbody><tr>
                <td style='background: transparent url(skins/mobilstore/images/side.gif) repeat-x scroll left bottom; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
                  <table style='background: transparent url(skins/mobilstore/images/side.gif) repeat-y scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                    <tbody><tr>
                      <td style='background: transparent url(skins/mobilstore/images/side.gif) repeat-y scroll right bottom; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial; width: 100%;'>
                        <table style='background: transparent url(skins/mobilstore/images/ltc.gif) no-repeat scroll left top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                          <tbody><tr>
                            <td style='background: transparent url(skins/mobilstore/images/rtc.gif) no-repeat scroll right top; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                              <table style='background: transparent url(skins/mobilstore/images/lbc.gif) no-repeat scroll left bottom; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
                                <tbody><tr>
                                  <td style='background: transparent url(skins/mobilstore/images/rbc.gif) no-repeat scroll right bottom; width: 100%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>


						
							
							
							
							<table style='width: 100%;'>
								  <tbody><tr>
									<td style='height: 13px;'></td>
								  </tr>
								  <tr>
									<td style='width: 100%;'>
									  <table style='width: 100%;'>
										<tbody><tr>
										  <td style='background: transparent url(skins/mobilstore/images/price_stick.gif) no-repeat scroll right top; width: 40%; -moz-background-clip: -moz-initial; -moz-background-origin: -moz-initial; -moz-background-inline-policy: -moz-initial;'>
											<table>
											  <tbody><tr>
												<td style='text-align: center; padding-top: 2px;' class='price2_padd vam noWrap'>
													<span class='productOldPrice'>{3}</span>&nbsp;&nbsp;<span class='productSpecialPrice'>{4}</span>
												
												</td>
											  </tr>
											</tbody></table>
										  </td>
										  <td style='width: 60%;'>
											<table>
											  <tbody><tr>
												<td style='padding-left:10px;'><a class='buttonDetails' href='{0}'>&nbsp;</a></td>
												<td style='padding-right:10px;'><a class='buttonAddToCart' style='{12}' href='./' onclick='{11}'>&nbsp;</a></td>
											  </tr>
											</tbody></table>
										  </td>
										</tr>
									  </tbody></table>
									</td>
								  </tr>
								  <tr>
									<td style='height: 14px;'></td>
								  </tr>
								</tbody></table>
								
								
   
                                  </td>
                                </tr>
                              </tbody></table>
                            </td>
                          </tr>
                        </tbody></table>
                      </td>
                    </tr>
                  </tbody></table>
                </td>
              </tr>
            </tbody></table>											  
					
   						
							
							</td>
						  </tr>
						</tbody></table>

                                  </td>
                                </tr>
                              </tbody></table>
                            </td>
                          </tr>
                        </tbody></table>
                      </td>
                    </tr>
                  </tbody></table>
                </td>
              </tr>
            </tbody></table>											  
					
   
		
		",
		 pd.DetailsLink,
		 pd.SmallImageLink,
		 pd.Name,
		pd.OriginalPriceStr,
		pd.CurrentPriceStr,
		 pd.Product.SKU,
		 GetManufacturerLink(pd.Product.GetManufacturer()),
		 pd.Product.GetManufacturer().Name,
		 pd.Product.StockQuantity,
		pd.Product.Weight,
		GetShortDescription(pd.Product),
		"Ice.GCart.AddProductToCart(" + pd.Product.ProductID + "); return false;",
		pd.Product.StockQuantity > 0 ? "" : "display:none"
		 );

			return html;

		}

		private string GetShortDescription(Product product)
		{
			//if(product.ShortDescription.Length == 0)
			//{
			//    return CommonUtility.GetTextInLength(product.LongDescription, 50);
			//}
			//else
			{
				return CommonUtility.GetTextInLength(product.ShortDescription, 50);
			}
		}

		private string GetManufacturerLink(Manufacturer manufacturer)
		{
			FrontParameters fp = new FrontParameters();
			fp.ManufacturerID = manufacturer.ManufacturerID;
			return fp.RelativeLink;
		}

		#endregion


	}
}