#region License, Terms and Author(s)
//
// ELMAH - Error Logging Modules and Handlers for ASP.NET
// Copyright (c) 2004-9 Atif Aziz. All rights reserved.
//
//  Author(s):
//
//      Atif Aziz, http://www.raboof.com
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#endregion

[assembly: Ice.Elmah.Scc("$Id: ErrorFilterConfiguration.cs 566 2009-05-11 10:37:10Z azizatif $")]

namespace Ice.Elmah
{
    #region Imports

    using System;
    using Elmah.Assertions;

    #endregion

    public class ErrorFilterConfiguration : ICloneable
    {
        private IAssertion _assertion = StaticAssertion.False;

        public IAssertion Assertion
        {
            get { return _assertion; }
        }

        internal void SetAssertion(IAssertion assertion)
        {
            _assertion = assertion != null ? assertion : StaticAssertion.False;
        }

        object ICloneable.Clone()
        {
            return Clone();
        }

        protected virtual object Clone()
        {
            return MemberwiseClone();
        }
    }
}