﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Ice.Orm.Core.Criteria.SqlBlocks
{
	internal class SqlSegmentCollection
	{
		private List<SqlSegment> _segments = new List<SqlSegment>();

		public void Add(string text)
		{
			_segments.Add(new SqlSegment(text));
		}

		public void Add(QParameter par)
		{
			_segments.Add(new SqlSegment(par));
		}

		public void Add(SqlName name)
		{
			_segments.Add(new SqlSegment(name));
		}

		public void Add(SqlSegment segment)
		{
			_segments.Add(segment);
		}

		public IEnumerable<SqlSegment> AsEnumerable()
		{
			return _segments;
		}

		public void AddRange(SqlSegmentCollection segments)
		{
			_segments.AddRange(segments.AsEnumerable());
		}

		public bool Any()
		{
			return _segments.Any();
		}

		public void Clear()
		{
			_segments.Clear();
		}

		public void Insert(int index, string text)
		{
			_segments.Insert(index, new SqlSegment(text));
		}


	}
}
