﻿using System;
using System.Collections;
using System.Data;
using System.Data.Odbc;
using System.Text;
using System.Collections.Generic;
using System.Data.Common;
using System.Threading;

namespace Ice.Orm.Core.DataStore
{
	using Criteria;
	using Entity;
	using Utility;
	using Schema;

	public class ConnectionContext
	{
		private IDbTransaction mTransaction = null;
		private Thread mThreadOwner = null;
		private readonly object mLockDbConnection = new object();
		private IDbConnection mDbConnection = null;
		private int mEnterCount = 0;

		public Thread ThreadOwner
		{
			get { return mThreadOwner; }
			set { mThreadOwner = value; }
		}

		public IDbTransaction Transaction
		{
			get { return mTransaction; }
			set { mTransaction = value; }
		}

		public IDbConnection DbConnection
		{
			get { return mDbConnection; }
			set { mDbConnection = value; }
		}

		public ConnectionContext()
		{
		}

		public bool IsBussy
		{
			get { return mEnterCount > 0; }
			set
			{
				if (value)
				{
					mEnterCount++;
				}
				else
				{
					mEnterCount--;
					if (mEnterCount < 1)
					{
						mEnterCount = 0;
					}
				}
			}
		}
	}



}

