﻿using System;

namespace Ice.Orm.Core.DataStore
{
	public class DataStoreSelector
	{
		public static DataStoreBase GetDataStore(DataStoreSetting dbSetting)
		{
			switch (dbSetting.DBProvider)
			{
				case DataStoreProviderEnum.SQL:
					return new MSSQL.MSSQLDataStore(dbSetting);

				case DataStoreProviderEnum.SQLCE:
					return new MSSQLCE.MSSQLCEDataStore(dbSetting);

				case DataStoreProviderEnum.ODBC:
					return new ODBC.ODBCDataStore(dbSetting); // generic ODBC data store

				case DataStoreProviderEnum.OLEDB:
					return new OLEDB.OleDbDataStore(dbSetting); // generic OLE DB data store

				case DataStoreProviderEnum.ORACLE:
					return new ORACLE.OracleDataStore(dbSetting);

				case DataStoreProviderEnum.MYSQL:
					return new MySQL.MySQLDataStore(dbSetting);

				case DataStoreProviderEnum.SQLITE:
					return new SQLITE.SQLiteDataStore(dbSetting); // loading System.Data.SQLite throw exception in not FULL trust security

				default:
					throw new Exception("Provider " + dbSetting.DBProvider + " not implemented!");
			}

		}
	}
}
