﻿using System.Data;
using System.Data.OleDb;
using System;

namespace Ice.Orm.Core.DataStore.OLEDB
{
	using Schema;
	using Criteria;
	using Ice.Orm.Core.Entity;

	/// <summary>
	/// Generic OLE DB data store
	/// </summary>
	public class OleDbDataStore : DataStoreBase
	{
		public OleDbDataStore(DataStoreSetting dbSetting)
			: base(dbSetting)
		{
		}

		protected override IDbConnection NewDbConnection()
		{
			return new OleDbConnection();
		}

		protected override IDbCommand NewDbCommand()
		{
			return new OleDbCommand();
		}

		protected override IDbDataAdapter NewDbDataAdapter()
		{
			return new OleDbDataAdapter();
		}

		protected override IDbDataParameter CreateIDbDataParameter(string parameterName, object value, EntityFieldSetting schemaColumn)
		{
			if (schemaColumn != null && schemaColumn.ColumnSize > 65535)
			{
				schemaColumn.ColumnSize = 65535;
			}

			OleDbParameter parameter = new OleDbParameter(parameterName, value);

			FixDbParameterValueAndType(parameter, schemaColumn);

			if(schemaColumn != null)
			{
				// enters here only if schemaColumn != null

				////if (schemaColumn.SqlDbType >= 0)
				////{
				////    parameter.OleDbType = Utility.TypeConverters.GetOleDbType(schemaColumn.SqlDbType);
				////}

				if (schemaColumn.ColumnSize > 255)
				{
					parameter.OleDbType = OleDbType.VarWChar;
				}

				if (schemaColumn.ProviderType != null)
				{
					parameter.OleDbType = (OleDbType)schemaColumn.ProviderType;
				}
			}

			return parameter;
		}

	}
}
