﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ice.Orm.Core.Criteria;
using System.Linq.Expressions;

namespace Ice.Orm.Core.LINQ
{
	internal class WhereSqlFormater : SqlFormater
	{
		public WhereSqlFormater(QueryBase q)
		{
			this.query = q;
		}

		public new Expression Visit(Expression exp)
		{
			return base.Visit(exp);
		}

		protected override Expression VisitLambda(LambdaExpression lambda)
		{
			//// to handle .Where(o=>o.Active)
			return this.VisitPredicate(lambda.Body);
		}

		protected override void WriteValue(object value)
		{
			// if value is null, don't create QParamter, add NULL to sql text instead

			if (value == null || value == System.DBNull.Value)
			{
				base.WriteValue(value);
			}
			else
			{
				base.LastParameter = new QParameter(value, this.LastColumnName);
				base.LastColumnName = null; // once tmpColumnName is used, remove it
				base.WriteParameter(base.LastParameter);
			}
		}


	}
}
