﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace Ice.Colorspace
{
	public static class ColorExtensions
	{
		public static Color FromHtml(string htmlColor)
		{
			return System.Drawing.ColorTranslator.FromHtml(htmlColor);
		}

		public static string ToHtml(this Color color)
		{
			return System.Drawing.ColorTranslator.ToHtml(color);
		}

		public static Color ChangeSaturationPercent(this Color color, double saturationChangePercent)
		{
			HSL hsl = Ice.Colorspace.ColorSpaceHelper.ColorToHSL(color);

			if (saturationChangePercent != 0)
			{
				hsl.Saturation += hsl.Saturation * saturationChangePercent / 100;
			}

			return ColorSpaceHelper.HSLtoColor(hsl);
		}

		public static Color ChangeLightnesPercent(this Color color, double lightnesChangePercent)
		{
			HSL hsl = Ice.Colorspace.ColorSpaceHelper.ColorToHSL(color);
			if (lightnesChangePercent != 0)
			{
				hsl.Luminance += hsl.Luminance * lightnesChangePercent / 100;
			}

			return ColorSpaceHelper.HSLtoColor(hsl);
		}
	}
}
