﻿#if !SILVERLIGHT

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;

namespace Ice.Net.Sockets.SocketTest
{
	public class IceSocketTest
	{
		IceServerSocket _server;
		IceClientSocket _client;

		public void StartTest()
		{
			// start server
			_server = new IceServerSocket(new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp), new IPEndPoint(IPAddress.Any, 1000));
			_server.DataReceived += server_DataReceived;
			_server.StartServer();

			// start client
			_client = new IceClientSocket(new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp), new IPEndPoint(IPAddress.Parse("127.0.0.1"), 1000));
			_client.DataReceived += client_DataReceived;
			_client.Connect();

			// tests:
			_client.Send("?");
			_client.Send("ime?");
		}

		void server_DataReceived(IceServerSocket server, EndPoint senderEP, byte[] data)
		{
			string str = Encoding.UTF8.GetString(data);

			switch (str)
			{
				case "connect":
					server.SendTo(senderEP, "* you're connected *");
					break;
				case "?":
					server.SendTo(senderEP, "ja sam server na masterovom kompu");
					break;
				case "ime?":
					server.SendTo(senderEP, "moje ime je John Doe");
					break;
				default:
					server.SendTo(senderEP, "komanda nije prepoznata");
					break;
			}
		}

		void client_DataReceived(IceClientSocket socket, EndPoint fromEndpoint, byte[] data)
		{
			// listHistory.Items.Add(Encoding.UTF8.GetString(data));
		}


	}
}

#endif
