﻿
namespace Ice.Serialization.Json.Core.Serializer
{
	using System;
	using System.Collections.Generic;

	/// <summary>
	/// Includes Ice converters
	/// </summary>
	public class IceJavaScriptSerializer : JavaScriptSerializer
	{
		private static List<JavaScriptConverter> mConverters = new List<JavaScriptConverter>()
		{
#if !SILVERLIGHT
				new Converters.DataTableConverter(),
#endif
				new Converters.IceDateTimeConverter()
		};

		public Object ConvertToType(object obj, Type outputType)
		{
			return ObjectConverter.ConvertObjectToType(obj, outputType, this);
		}

		public Object Deserialize(string input, Type outputType)
		{
			return Deserialize(this, input, outputType, this.RecursionLimit);
		}

		/// <summary>
		/// <para>Added converters:</para>
		/// <para>DataTable</para>
		/// <para>GDataTable</para>
		/// </summary>
		public IceJavaScriptSerializer(bool includePropertyTypesComments = false) : base(includePropertyTypesComments)
		{
			this.RegisterConverters(mConverters);
		}
	}
}
