﻿#if !SILVERLIGHT

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32;

namespace Ice.Win32
{
	public class RegistryTools
	{
		public void WriteRegistry(RegistryKey parentKey, String subKey, String valueName, Object value)
		{
			RegistryKey key = parentKey.OpenSubKey(subKey, true);
			if (key == null)
			{
				//create subKey
				key = parentKey.CreateSubKey(subKey);
			}
			key.SetValue(valueName, value);
		}

		/// <summary>
		/// returns object value, null if not found (subKey or valueName)
		/// </summary>
		public Object ReadRegistry(RegistryKey parentKey, String subKey, String valueName)
		{
			RegistryKey key = parentKey.OpenSubKey(subKey);
			if (key != null)
			{
				return key.GetValue(valueName);
			}
			else
			{
				return null;
			}
		}
	}
}

#endif
