﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace Ice.Xml.Parser
{
	[DebuggerDisplay("#root")]
	public class XmlDocument : XmlNode
	{
		/// <summary>
		/// parse html, returns #root node
		/// </summary>
		/// <param name="html"></param>
		/// <returns></returns>
		public static XmlDocument Parse(string str, SourceKindEnum kind = SourceKindEnum.Html)
		{
			return XmlParser.Parse(str, kind);
		}

		public static XmlDocument ParseHtml(string html)
		{
			return XmlParser.Parse(html, SourceKindEnum.Html);
		}

		public static XmlDocument ParseXml(string xml)
		{
			return XmlParser.Parse(xml, SourceKindEnum.Xml);
		}

		public static XmlDocument ParseJson(string json)
		{
			return XmlParser.Parse(json, SourceKindEnum.Json);
		}

		public override string OutterXml
		{
			get
			{
				return base.InnerXml;
			}
		}
	}


}
