﻿#if !SILVERLIGHT

using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace System.Xml
{
	public static class XmlExtensions
	{
		public static IEnumerable<XmlNode> DescendantNodes(this XmlNode node)
		{
			if (node.ChildNodes != null && node.ChildNodes.Count > 0)
			{
				foreach (XmlNode n in node.ChildNodes)
				{
					yield return n;

					foreach (XmlNode n1 in n.DescendantNodes())
					{
						yield return n1;
					}
				}
			}
		}

		public static IEnumerable<XmlNode> AncestorNodes(this XmlNode node)
		{
			while ((node = node.ParentNode) != null)
			{
				yield return node;
			}
		}
	}


}

#endif

