﻿/// <reference path="Ice.js" />

//WARNING: overloaded string methods create this as object, must convert it to string because comparison with string won't work

(function ()
{
	if (!String.IsNullOrEmpty)
	{
		String.IsNullOrEmpty = function (str1, str2, str3, etc)
		{
			/// <summary>
			/// returns true if any of strings is null or empty or undefined
			/// </summary>
			/// <param name="str1"></param>
			/// <param name="str2"></param>
			/// <param name="str3"></param>
			/// <param name="etc"></param>
			return Ice.String.IsNullOrEmpty.apply(this, arguments);
		};
	}



	var methods =
	{
		Equals: function (secondStr, ignoreCase)
		{
			/// <summary>
			/// Compare two string
			/// </summary>
			/// <param name="secondStr"></param>
			/// <param name="ignoreCase"></param>

			return Ice.String.Equals(this, secondStr, ignoreCase);
		},

		EndsWith: function (secondStr, ignoreCase)
		{
			return Ice.String.EndsWith(this, secondStr, ignoreCase);
		},

		StartsWith: function (secondStr, ignoreCase) { return Ice.String.StartsWith(this, secondStr, ignoreCase); },

		Contains: function (secondStr, ignoreCase) { return Ice.String.Contains(this, secondStr, ignoreCase); },

		TrimStart: function (charsArray) { return Ice.String.TrimStart(this, charsArray); },

		TrimEnd: function (charsArray) { return Ice.String.TrimEnd(this, charsArray); },

		Trim: function (charsArray) { return Ice.String.Trim(this, charsArray); },

		Substring: function (startIndex, length) { return Ice.String.Substring(this, startIndex, length); },

		Remove: function (startIndex) { return Ice.String.Remove(this, startIndex); },

		Repeat: function (count)
		{
			/// <summary>repeated string count times</summary>
			/// <param name="count" type="Number">The number of times to repeat the str in the generated sequence.</param>
			return Ice.String.Repeat(this, count);
		},

		TakeFirst: function (count, elipsis) { return Ice.String.TakeFirst(this, count, elipsis); },

		TakeLast: function (count, elipsis) { return Ice.String.TakeLast(this, count, elipsis); },

		Split: function (splitByCharsArr) { return Ice.String.Split(this, splitByCharsArr); },

		ReplaceAll: function (search, replacement)
		{
			/// <summary>
			/// Replace all occurances of search pattern with replacement.
			/// </summary>
			/// <param name="search"></param>
			/// <param name="replacement"></param>

			return Ice.String.ReplaceAll(this, search, replacement);
		},

		FormatWith: function (obj, placeHolderStart, placeHolderEnd)
		{
			/// <summary>
			/// 
			/// </summary>
			/// <param name="str">input string with property names or array indexes: My name is {Name}, or My name is {0}</param>
			/// <param name="obj" type="Object|Array">object with properties {Name:Tom, Age:22, ...} or array["Tom", 22"...]</param>
			/// <param name="placeHolderStart" optional="true" type="String">default {</param>
			/// <param name="placeHolderEnd" optional="true" type="String">default }</param>

			return Ice.String.FormatWith(this, obj, placeHolderStart, placeHolderEnd);
		},

		AsEnumerable: function ()
		{
			/// <summary>
			/// Creates new Ice.List instance from current string.
			/// </summary>

			return new Ice.List(this);
		},

		ToNumber: function()
		{
			return parseFloat(this);
		}
	};

	// finally, assign properties
	Ice.ForEachProperties(methods, function (propName, propValue, index)
	{
		if (typeof (String.prototype[propName]) == "undefined")
		{
			String.prototype[propName] = propValue;
		}
	});

})();