﻿/// <reference path="Ice.DomQuery.js" />

Ice.RegisterNs("Ice.Web.UI.WebControls");
Ice.RegisterNs("Ice.Web.UI.Utility");
Ice.RegisterNs("Ice.Web.UI.Utility.Table");

Ice.Web.UI.Utility.Table.MakeSortable = function (tableSelector, descFirst)
{
	var table = $$ice(tableSelector).First();
	var headTds = $$ice(table).Query("table tr:take(1)>td").ToDomQuery();

	function SortBy(sender)
	{
		////// remove previous arrows
		////headTds.ChildNodes("span").RemoveFromDom();

		////var enArrow = new Ice.DomQuery.HtmlElement("span")
		////	.ApplyStyle("position:absolute;margin-left:3px;margin-top:-2px;")
		////	//.SetInnerHtml(sender._asc ? " &or;" : "&and;")
		////	.SetInnerHtml(sender._asc ? "&uarr;" : "&darr;")
		////;

		////$$ice(sender).AddChildren(enArrow);

		// get index
		var tdIndex = $$ice(sender).PreviousSiblings("td").Count();

		var items = $$ice(tableSelector).Query("table tr:skip(1)").Select(function (tr)
		{
			var val = $$ice(tr).ChildNodes("td")
					.Where(function (o, n) { return n == tdIndex; })
					.Select(function (o) { return Ice.Utility.Dom.GetInnerText(o); })
					.FirstOrDefault();

			var numStr = (val || "").ReplaceAll(",", ".").ReplaceAll(" ", "").ReplaceAll(" " /*xA0 or &nbsp;*/, ""); // eg. - 55,66 convert to US and remove space: -5566
			var number = parseFloat(numStr);
			var txt = val.toLowerCase();
			var considerNumber = numStr == "" || numStr == " "/*&nbsp;*/ || numStr == (number + "") || numStr.indexOf(number + "") == 0;

			return {
				el: tr,
				str: txt,
				//numStr: numStr,
				num: isNaN(number) || (considerNumber && isNaN(number)) ? -9007199254740991 : number,
				//isNotNum: isNaN(number),
				// eg. -33.50 is the same as -33.5
				// run numeric compare if all values are numbers or empty
				isNum: considerNumber
			};

		}).ToDomQuery();

		if (table._sortColumn != sender)
		{
			// when column is changed, remove previous sort and start from beginning
			sender._sort = null;
		}

		$$ice(sender).Query("<>td").RemoveClass("sortasc").RemoveClass("sortdesc");

		switch (sender._sort)
		{
			case "desc":
				sender._sort = "asc";
				break;
			case "asc":
				sender._sort = "desc";
				break;
			default:
				sender._sort = descFirst ? "desc" : "asc";
				break;
		}

		if (sender._sort)
		{
			$$ice(sender).AddClass("sort" + sender._sort);
		}

		var numericSort = items.All("o=>o.isNum");

		// sort in reversed order than was the first time
		// asc or desc
		items = items.OrderBy(numericSort ? "o=>o.num" : "o=>o.str", sender._sort == "desc").ToDomQuery();

		table._sortColumn = sender;

		items.ForEach(function (o) { o.el.parentNode.appendChild(o.el); });
	}

	headTds.OnHover(function (sender, ev)
	{
		this.style.cursor = "pointer";
		this.style.textDecoration = "underline";
	}, function (sender, ev)
	{
		this.style.cursor = "";
		this.style.textDecoration = "";
	})
	.OnClick(function (sender, ev)
	{
		SortBy(sender);
	});

};





