﻿

Ice.Console = new (function ()
{
	this.typeName = "Ice.Console";

	var mConsole = null;
	var mConsoleHolder = null;

	function EnsureCreated()
	{
		if (mConsole == null)
		{
			var tmp = document.createElement("div");
			tmp.innerHTML = "<div style='position:fixed; right:10px; top:30px; font-size:10px; font-family:Tahoma; width:400px; height:400px; z-index:100043264;'>"
			+ "<div style='color:white;background-color:black;font-weight:bold;border-radius:3px 3px 0 0;position:absolute;width:100%;margin:-22px 0 0 0px;'>"
			+ "<div style='margin:5px;'>Ice.Console</div>"
			+ "</div>"
			+ "<div style='overflow:auto; background-color:white; height:100%;border:solid 2px black; border-width:0 2px 2px 2px;border-radius:0 0 3px 3px; padding:3px;'></div>"
			+ "</div>";
			mConsoleHolder = tmp.firstChild;
			(document.body || document.documentElement || document).appendChild(mConsoleHolder);
			mConsole = mConsoleHolder.childNodes[1];
			new Ice.Draggable(mConsoleHolder, mConsoleHolder.childNodes[0]).Start();
		}
	}

	this.Write = function (msg)
	{
		/// <summary>
		/// write message to the console
		/// </summary>
		/// <param name="msg"></param>

		EnsureCreated();

		var msg = Ice.Utility.Html.HtmlEncodeSimple(msg + "");

		mConsole.innerHTML += msg;

		return this;
	};

	this.WriteLine = function (msg, insertToTop)
	{
		/// <summary>
		/// write line to the console
		/// </summary>
		/// <param name="msg"></param>

		EnsureCreated();

		var msg = Ice.Utility.Html.HtmlEncodeSimple(msg + "");

		if (insertToTop)
		{
			mConsole.innerHTML = msg + "<hr/>" + mConsole.innerHTML;
		}
		else
		{
			mConsole.innerHTML += msg;
			var hr = document.createElement("hr");
			mConsole.appendChild(hr);
			hr.scrollIntoView();
		}
		return this;
	};

	this.InsertLine = function (msg)
	{
		this.WriteLine(msg, true);
	};

	function SetIfDefined(name, value)
	{
		if (typeof (value) == "number")
		{
			mConsoleHolder.style[name] = value + "px";
		}
	}

	this.SetSize = function (width, height)
	{
		EnsureCreated();
		SetIfDefined("width", width);
		SetIfDefined("height", height);
		return this;
	};

	this.SetPosition = function (top, left, right, bottom)
	{
		EnsureCreated();
		SetIfDefined("top", top);
		SetIfDefined("left", left);
		SetIfDefined("right", right);
		SetIfDefined("bottom", bottom);
		return this;
	};

	this.SetOptions = function (width, height, top, left, right, bottom)
	{
		/// <summary>
		/// set console options
		/// </summary>
		/// <param name="width" type="Number">required, width number of pixels</param>
		/// <param name="height" type="Number">required</param>
		/// <param name="top" type="Number|Null">optional</param>
		/// <param name="left" type="Number|Null">optional</param>
		/// <param name="right" type="Number|Null">optional</param>
		/// <param name="bottom" type="Number|Null">optional</param>
		this.SetSize(width, height);
		this.SetPosition(top, left, right, bottom);
		return this;
	};



})();

