﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ice.Web.UI;
using System.IO;
using System.Web.UI;
using Ice.Web.UI.Css;

namespace Ice.Web.Resources.Themes
{
	/// <summary>
	/// Default theme for Ice controls to work. Ice controls styles are applied in the code, without using css class names.
	/// </summary>
	class ThemeBase
	{
		public virtual IceThemeEnum Theme { get { return IceThemeEnum.Basic; } }
		public virtual string ButtonBackgroundImage { get { return IceScriptManager.CreateUrl(".Aero.Images.btnback.png"); } }
		public virtual string CheckboxBackgroundImage { get { return IceScriptManager.CreateUrl(".Aero.Images.green_checkbox.png"); } }
		public virtual string RadioboxBackgroundImage { get { return IceScriptManager.CreateUrl(".Aero.Images.green_radio.png"); } }
		public virtual string ButtonBackgroundColor { get { return "#E2E2E2"; } }
		public virtual string ButtonBorderColor { get { return "gray"; } }
		public virtual string ButtonTextColor { get { return "black"; } }
		public virtual string FrameColor { get { return "#F0F0F0"; } }
		public virtual string FrameBorderColor { get { return "gainsboro"; } }
		public virtual string SplitBarHoverColor { get { return "#E2E2E2"; } }
		public virtual string WindowFrameColor { get { return "#1A6F96"; } }
		public virtual string ButtonHoverColor { get { return "#08FFFF"; } }

		protected virtual void WriteThemeCss(IceStyleSheet styleSheet)
		{

////.row-of-icons {
////  -webkit-user-select: none;  /* Chrome all / Safari all */
////  -moz-user-select: none;     /* Firefox all */
////  -ms-user-select: none;      /* IE 10+ */

////  /* No support for these yet, use at own risk */
////  -o-user-select: none;
////  user-select: none;          
////}
		
			// Formal syntax: none | text | all | element
			styleSheet.AddCss(@"
.iceNoUserSelect {
	-webkit-touch-callout: none;
	-webkit-user-select: none;
	-khtml-user-select: none;
	-moz-user-select: none;
	-ms-user-select: none;
	-o-user-select: none;
	user-select: none;
}

");

		}

		public string ThemeCss{get; private set;}

		public ThemeBase()
		{
			IceStyleSheet sheet = new IceStyleSheet();
			this.WriteThemeCss(sheet);
			this.ThemeCss = sheet.ToCssString();
		}
	}
}
