﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ice.Web.UI;

namespace Ice.Web.Resources.Themes
{
	class ThemeHelper
	{
		static Dictionary<IceThemeEnum, ThemeBase> ThemesCache = new[]
		{
			new KeyValuePair<IceThemeEnum, ThemeBase>(IceThemeEnum.Basic, new ThemeBase()),
			new KeyValuePair<IceThemeEnum, ThemeBase>(IceThemeEnum.Aero, new Aero()),
			new KeyValuePair<IceThemeEnum, ThemeBase>(IceThemeEnum.DeepBlue, new DeepBlue()),
			new KeyValuePair<IceThemeEnum, ThemeBase>(IceThemeEnum.LightBlue, new LightBlue()),
			new KeyValuePair<IceThemeEnum, ThemeBase>(IceThemeEnum.Silver, new Silver()),
			new KeyValuePair<IceThemeEnum, ThemeBase>(IceThemeEnum.Black, new Black()),
		}.ToDictionary(o => o.Key, o => o.Value);

		public static ThemeBase GetTheme(IceThemeEnum theme)
		{
			ThemeBase tt;
			ThemesCache.TryGetValue(theme, out tt);
			return tt;
		}
	}
}
