﻿
Ice.Web.UI.WebControls.IceDatePickerManager = new (function ()
{
	function GetWeeks(weekStart, currentDateTime)
	{
		/// <summary>
		/// 
		/// </summary>
		/// <param name="weekStart" type="Ice.DateTime"></param>
		/// <param name="currentDateTime" type="Ice.DateTime"></param>

		var rowsList = new Ice.List();
		var row = new Ice.List();
		rowsList.Add(row);

		for (var n = 0; n < 7; n++)
		{
			var dayName = weekStart.AddDays(n).ToStringFormated("ddd"); // short day name
			row.Add(dayName);
		}

		for (var w = 0; w < 6; w++)
		{
			row = new Ice.List();
			rowsList.Add(row);

			for (var n = 0; n < 7; n++)
			{
				row.Add(weekStart.AddDays(n + (w * 7)));
			}
		}

		return rowsList;
	}

	function IsCurrentMonth(parts, date)
	{
		var p = date.ToParts();
		return parts.Month == p.Month && parts.Year == p.Year;
	}

	function IsCurrentDay(parts, date)
	{
		var p = date.ToParts();
		return parts.Day == p.Day && parts.Month == p.Month && parts.Year == p.Year;
	}

	function GetWeekStart(picker, currentDateTime)
	{
		var currParts = currentDateTime.ToParts();
		var weekStart = Ice.DateTime.Create(currParts.Year, currParts.Month);
		while (weekStart.ToParts().DayOfWeek != picker.WeekStartDay)
		{
			weekStart = weekStart.AddDays(-1);
		}
		return weekStart;
	}

	function BuildMonthView(picker, calendar, currentDateTime)
	{
		var weekStart = GetWeekStart(picker, currentDateTime);

		var rowsList = GetWeeks(weekStart, currentDateTime);

		var html =
		"<table>"
		+ "<tr class='currHead'><td onclick='Ice.Web.UI.WebControls.IceDatePickerManager.Adjust(this, -1)'>&lt;</td><td colspan='5' onclick='Ice.Web.UI.WebControls.IceDatePickerManager.ChangeView(this)'><b>" + currentDateTime.ToStringFormated("MMMM, yyyy") + "</b></td><td onclick='Ice.Web.UI.WebControls.IceDatePickerManager.Adjust(this, 1)'>&gt;</td></tr>"
		+ rowsList.Take(1).Select(function (row, index)
		{
			return "<tr class='wdays'>" + row.Select(function (item) { return "<td>" + item + "</td>"; }).ToStringJoined() + "</tr>";
		}).ToStringJoined()
		////+ rowsList.Skip(1).Select(function (row, index)
		////{
		////	return "<tr class='selectable'>" + row.Select(function (item) { return "<td>" + item.ToStringFormated("d") + "</td>"; }).ToStringJoined() + "</tr>";
		////}).ToStringJoined()
		+ "<tr class='today' onclick='Ice.Web.UI.WebControls.IceDatePickerManager.SetTodaysDateTime(this)'><td colspan='7'>Today: " + Ice.DateTime.Now().ToStringFormated("MMMM dd, yyyy") + "</td></tr>"
		+ "</table>";

		var trToday = $$ice(picker.Calendar).SetInnerHtml(html).DescendantNodes("tr.today").Take(1).ToDomQuery();

		var parts = currentDateTime.ToParts();
		var todaysDate = Ice.DateTime.Now().ToParts();

		rowsList.Skip(1).ForEach(function (row, index)
		{
			var tr = document.createElement("tr");
			trToday.InsertBefore(tr);
			tr.className = 'selectable';
			row.ForEach(function (date)
			{
				var td = document.createElement("td");
				tr.appendChild(td);
				td.__iceCellDateTime = date;
				$$ice(td).SetInnerHtml(date.ToStringFormated("d"));
				if (!IsCurrentMonth(parts, date))
				{
					$$ice(td).AddClass("not-current-month");
				}
				if (IsCurrentDay(todaysDate, date))
				{
					$$ice(td).AddClass("todaysDay");
				}

				$$ice(td).OnClick(function (sender, ev)
				{
					picker.VisibleDateTime = td.__iceCellDateTime;
					picker.TargetEl.value = td.__iceCellDateTime.ToStringFormated(picker.DateTimeFormat);
					picker.Hide();
				});
			});
		});
	}

	function GetMonths(currentDateTime)
	{
		/// <summary>
		/// 
		/// </summary>
		/// <param name="currentDateTime" type="Ice.DateTime"></param>

		var dt = Ice.DateTime.Create(currentDateTime.ToParts().Year);
		var rowsList = new Ice.List();
		for (var rr = 0; rr < 3; rr++)
		{
			var row = new Ice.List();
			rowsList.Add(row);

			for (var dd = 0; dd < 4; dd++)
			{
				row.Add(dt.AddMonths(dd + (rr * 4)));
			}
		}
		return rowsList;
	}

	function BuildYearView(picker, calendar, currentDateTime)
	{
		var rowsList = GetMonths(currentDateTime);

		var html =
		"<table>"
		+ "<tr class='currHead'><td onclick='Ice.Web.UI.WebControls.IceDatePickerManager.Adjust(this, -1)'>&lt;</td><td colspan='2' onclick='Ice.Web.UI.WebControls.IceDatePickerManager.ChangeView(this)'><b>" + currentDateTime.ToStringFormated("yyyy") + "</b></td><td onclick='Ice.Web.UI.WebControls.IceDatePickerManager.Adjust(this, 1)'>&gt;</td></tr>"
		////+ rowsList.Select(function (row, index)
		////{
		////	return "<tr class='selectable month'>" + row.Select(function (item) { return "<td>" + item + "</td>"; }).ToStringJoined() + "</tr>";
		////}).ToStringJoined()
		+ "<tr class='today' onclick='Ice.Web.UI.WebControls.IceDatePickerManager.SetTodaysDateTime(this)'><td colspan='4'>Today: " + Ice.DateTime.Now().ToStringFormated("MMMM dd, yyyy") + "</td></tr>"
		+ "</table>";

		var trToday = $$ice(picker.Calendar).SetInnerHtml(html).DescendantNodes("tr.today").Take(1).ToDomQuery();

		rowsList.ForEach(function (row, index)
		{
			var tr = document.createElement("tr");
			trToday.InsertBefore(tr);
			tr.className = 'selectable month';
			row.ForEach(function (date)
			{
				var td = document.createElement("td");
				tr.appendChild(td);
				td.__iceCellDateTime = date;
				$$ice(td).SetInnerHtml(date.ToStringFormated("MMM"));
				$$ice(td).OnClick(function (sender, ev)
				{
					picker.VisibleDateTime = sender.__iceCellDateTime;
					picker.CurrentView = 0;
					CreateView(picker);
				});
			});
		});
	}

	function CreateView(picker)
	{
		var html;
		if (picker.CurrentView == 1)
		{
			html = BuildYearView(picker, picker.Calendar, picker.VisibleDateTime);
		}
		else
		{
			html = BuildMonthView(picker, picker.Calendar, picker.VisibleDateTime)
		}
	}

	function Initialize(picker, targetEl, calendar)
	{
		$$ice(targetEl).InsertAfter(calendar);

		$$ice(calendar).OnHover(function (sender, ev)
		{
			sender.__iceDatePickerInstance.TargetEl.focus(); // firefox loses focus on click on calendar, regain the focus for events on input el to work
			sender.__isHover = true;
		}, function (sender, ev)
		{
			sender.__isHover = false;
		});

		$$ice(targetEl).OnClick(function (sender, ev)
		{
			CreateView(picker);
			$$ice(calendar).ApplyStyle("display:block"); // show calendar
		});

		$$ice(targetEl).OnKeyDown(function (sender, ev)
		{
			if (Ice.Event.IsEscKey(ev))
			{
				$$ice(calendar).ApplyStyle("display:none"); // hide calendar
			}
		});

		$$ice(targetEl).OnBlur(function (sender, ev)
		{
			var picker = sender.__iceDatePickerInstance;
			if ($$ice(picker.Calendar).Where("o=>o.__isHover").Any())
			{
				$$ice(sender).ForEach("o=>o.focus()");
			}
			else
			{
				$$ice(picker.Calendar).ApplyStyle("display:none");
			}
		});
	}

	function IceDateTimePicker(targetEl, dateTimeFormat, align)
	{
		var calendar = new Ice.DomQuery.HtmlElement("div")
			.AddClass("iceDatePicker")
			.First();

		this.WeekStartDay = Ice.DateTime.dateFormat.i18n.firstDayOfWeek; // Ice.DateTime.DayOfWeek.Monday;
		this.TargetEl = targetEl;
		this.Calendar = calendar;
		this.VisibleDateTime = new Ice.DateTime.Now();
		this.CurrentView = 0; // 0: month, 1:year
		this.DateTimeFormat = dateTimeFormat || "yyyy-MM-dd";

		calendar.__iceDatePickerInstance = this;
		targetEl.__iceDatePickerInstance = this;

		Initialize(this, targetEl, calendar);

		$$ice(calendar).ParentNodes().ApplyStyle("position:relative");

		if (align == "right")
		{
			$$ice(calendar).ApplyStyle("right:0");
		}

		this.Hide = function ()
		{
			$$ice(calendar).ApplyStyle("display:none");
		};
	}

	this.Setup = function (iceSelector, dateTimeFormat, align)
	{
		$$ice(iceSelector).ForEach(function (targetEl)
		{
			if (!targetEl.__iceDatePickerInstance)
			{
				new IceDateTimePicker(targetEl, dateTimeFormat, align);
			}
		});
	};

	this.GetPicker = function (sender)
	{
		/// <summary>
		/// 
		/// </summary>
		/// <param name="sender"></param>
		/// <returns type=""></returns>
		return $$ice(sender).AncestorNodes().Where("o=>o.__iceDatePickerInstance").Select("o=>o.__iceDatePickerInstance").First();
	};

	this.SetTodaysDateTime = function (sender)
	{
		var picker = this.GetPicker(sender);
		picker.VisibleDateTime = Ice.DateTime.Now();
		picker.TargetEl.value = picker.VisibleDateTime.ToStringFormated(picker.DateTimeFormat);
		picker.Hide();
		//CreateView(picker);
	};

	this.Adjust = function (sender, value)
	{
		var picker = this.GetPicker(sender);
		if (picker.CurrentView == 1) // year
		{
			picker.VisibleDateTime = picker.VisibleDateTime.AddYears(value);
		}
		else
		{
			picker.VisibleDateTime = picker.VisibleDateTime.AddMonths(value);
		}

		CreateView(picker);
	};

	this.ChangeView = function (sender)
	{
		var picker = this.GetPicker(sender);
		picker.CurrentView = (++picker.CurrentView % 2);
		CreateView(picker);
	};


})();

////Ice.Web.UI.WebControls.IceDatePickerManager.Setup("#txtDate2");