﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Globalization;
using System.Security.Permissions;
using System.Web;
using System.Web.UI;
using System.Web.Util;
using Ice.Web.UI.WebControls;
using System.Linq;
using Ice.Web.Extensions;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using Ice.Web.UI;
using System.Web.UI.WebControls;
using Ice.Web.Resources.Themes;

//*****************************************************************
// works with IceScriptManager and with MS ScriptManager
//*****************************************************************

namespace Ice.Web.UI.WebControls
{
	[ParseChildren(false)]
	[PersistChildren(true)]
    public class IcePanel : IceWebControl
    {
 		public string DefaultFocus { get; set; }

		public string DefaultButton { get; set; }

		public IcePanel()
			: base(HtmlTextWriterTag.Div)
		{
		}

		protected override void OnInit(EventArgs e)
		{
			base.OnInit(e);

			if (this.Page != null && !this.Page.IsInAsyncPostBack())
			{
				// script has to be loaded always, even if panel is not currently visible. It may be set visible later in UpdatePanel
				IceScriptManager.GetCurrent(this).RegisterScriptFile(this, ".IcePanel.IcePanel.js");
			}
		}

		protected override void Render(HtmlTextWriter writer)
		{
			if (!this.Visible)
			{
				return;
			}

			if (!this.DesignMode && !string.IsNullOrEmpty(this.DefaultButton))
			{
				Control button = this.FindControl(this.DefaultButton);
				if (!(button is IButtonControl))
				{
					throw new InvalidOperationException("DefaultButton of type IButtonControl can not be found");
				}
				this.Page.ExecuteJavaScript("Ice.Web.UI.WebControls.IcePanel.DefaultButton('" + this.ClientID + "', '" + button.ClientID + "')");

			}

			if (!this.DesignMode && !string.IsNullOrEmpty(this.DefaultFocus))
			{
				TextBox txt = this.FindControl(this.DefaultFocus) as TextBox;
				if (txt == null)
				{
					throw new InvalidOperationException("DefaultFocus of type TextBox can not be found");
				}
				this.Page.ExecuteJavaScript("Ice.Web.UI.WebControls.IcePanel.DefaultFocus('" + this.ClientID + "', '" + txt.ClientID + "')");
			}

			base.Render(writer);
		}


    }
}

