﻿

//Ice.Menu podrzava potpuno lazy loading, lazy rendering: svaki Ice.Menu i submenu Ice.Menu renderira html tek kad se pozove .Show()
// koristi css: IceTreeView\treeviewres\treeview.css

Ice.Web.UI.WebControls.MenuItem = function (parentMenu, configItem)
{
	var subMenu;
	this.typeName = "Ice.Web.UI.WebControls.MenuItem";
	this.Render = function ()
	{
		if (configItem == "-")
		{
			return new Ice.DomQuery.FromHtml("<div class='separator'></div>").First();
		}
		else
		{
			var isMouseOver;

			var node = Ice.DomQuery.FromHtml("<a class='menuItem' href='#" + configItem.name + "'><table cellpadding='0' cellspacing='0'><tr><td class='td1 " + configItem.cls + "'></td><td class='td2'>" + configItem.name + "</td></tr></table></a>")
			.AddChildren(configItem.items ? "<span class='morearr'>&gt;</span>" : null)
			.OnClick(function (sender, event)
			{
				if (configItem.clickHandler)
				{
					var root = parentMenu.GetRootMenu();
					var data = root ? root._data : null;
					if (root)
					{
						root._data = null;
						root.Hide();
					}
					if (data)
					{
						// delay action to let menu to hide, required for Safari, safari requires 100 ms minimum!!!
						setTimeout(function () { configItem.clickHandler(data); }, 100);
					}
					return false; // return to a onclick event to prevent redirecting
				}
			}).OnHover(function (sender, event)
			{
				isMouseOver = true;
				setTimeout(function ()
				{
					if (isMouseOver)
					{
						if (configItem.items && !subMenu)
						{
							subMenu = new Ice.Web.UI.WebControls.Menu(node, configItem.items, parentMenu);
						}

						if (subMenu)
						{
							subMenu.Show();
						}
					}
				}, 200);
			}, function (sender, event)
			{
				isMouseOver = false;
				setTimeout(function ()
				{
					if (!isMouseOver)
					{
						if (subMenu)
						{
							subMenu.Hide();
						}
					}
				}, 200);


			}).First();

			return node;
		}
	};
};

Ice.Web.UI.WebControls.Menu = function (parentEl, configItemsArray, parentMenu)
{
	/// <summary>
	/// 
	/// </summary>
	/// <param name="parent">parent element or parent Ice.Menu</param>
	/// <param name="configItemsArray"></param>

	var isMouseOver = false;
	var domEl;
	var isRendered;
	this.typeName = "Ice.Web.UI.WebControls.Menu";
	this.GetDomEl = function () { return domEl; };
	this.GetRootMenu = function () { return this._data ? this : parentMenu && parentMenu.GetRootMenu ? parentMenu.GetRootMenu() : null; };

	this.Render = function ()
	{
		if (configItemsArray && configItemsArray.length > 0)
		{
			var container = Ice.DomQuery.FromHtml("<div class='ice-contextmenu' oncontextmenu='return false' style='display:none'><div class='col1'></div></div>");
			domEl = container.First();
			var menuItems = new Ice.List(configItemsArray).Where("o=>!o.hidden").Select(function (o) { return new Ice.Web.UI.WebControls.MenuItem(this, o); } .BindContext(this)).ToList();

			$$ice(parentEl)
				.AddChildren(container
					.AddChildren(menuItems.Select(function (o) { return o.Render(); }).ToArray()));
		}
	};

	this.Hide = function ()
	{
		if (domEl)
		{
			$$ice(domEl).ApplyStyle("display", "none");
		}
	};

	var menuDim;
	var parentDim;

	this.Show = function ()
	{
		if (!isRendered)
		{
			isRendered = true;
			this.Render();
		}

		if (domEl)
		{
			var iceDomEl = $$ice(domEl).ApplyStyle("opacity", 100).ApplyStyle("display", "block");

			menuDim = menuDim || iceDomEl.SelectStyleMap(["clientWidth", "clientHeight"]).First();
			parentDim = parentDim || iceDomEl.ParentNodes().SelectStyleMap(["offsetWidth", "offsetHeight"]).First();

			if (parentMenu)
			{
				iceDomEl.ApplyStyle("margin-left", parentDim.offsetWidth - 3).ApplyStyle("margin-top", "-" + parentDim.offsetHeight + "px");
			}
			else // root menu
			{
				iceDomEl.OnHover(function (sender, event)
				{
					isMouseOver = true;
				}, function (sender, event)
				{
					isMouseOver = false;
				});

				$$ice(document).OnClick(function (sender, event)
				{
					if (!isMouseOver)
					{
						this.Hide();
					}
				} .BindContext(this));
			}

			iceDomEl.ApplyStyle("overflow:visible");
		};
	}
};


Ice.Web.UI.WebControls.ContextMenu = function (configArray)
{
	var menu = new Ice.Web.UI.WebControls.Menu(document.documentElement, configArray);

	this.ShowMenu = function (event, data)
	{
		menu._data = data;
		menu.Show();
		var domEl = menu.GetDomEl();
		$$ice(domEl).ApplyStyle("left", event.pageX).ApplyStyle("top", event.pageY);

		// move menu into view
		var viewport = Ice.Utility.Dom.GetViewportDimensions();
		var deltaY = viewport.top2 - event.pageY - domEl.offsetHeight;
		var deltaX = viewport.left2 - event.pageX - domEl.offsetWidth;
		if(deltaY < 0)
		{
			$$ice(domEl).ApplyStyle("top", "-=" + Math.abs(deltaY));
		}
		if(deltaX < 0)
		{
			$$ice(domEl).ApplyStyle("left", "-=" + Math.abs(deltaX));
		}
	};

	this.HideMenu = function ()
	{
		menu.Hide();
	};
};




