﻿
Ice.Web.UI.WebControls.IceVerticalSplit = {};

Ice.Web.UI.WebControls.IceVerticalSplit.Setup = function (splitBarId, frameColor, hoverColor, leftMinWidth, leftMaxWidth, rightMinWidth, rightMaxWidth)
{
	var splitEL = $$ice("#" + splitBarId).First();
	if (splitEL.__iceVerticalSplit)
	{
		return;
	}
	splitEL.__iceVerticalSplit = true;

	var leftEL = $$ice(splitEL).PreviousSiblings("div").First();
	var rightEL = $$ice(splitEL).NextSiblings("div").First();
	var toLeft = splitEL.className.indexOf("toLeft") >= 0 ? true : splitEL.className.indexOf("toRight") >= 0 ? false : Ice.Diagnostic.Exception("IceVerticalSplit: direction unknown");
	var splitDim = $$ice(splitEL).SelectStyleMap(["width"]).First();
	var originalCursor = $$ice(splitEL).SelectStyle("cursor").First();
	var isCollapsed;
	var uncollpasedDim;
	var state;

	function SetWidth(width)
	{
		if (toLeft)
		{
			$$ice(leftEL).ApplyStyle("width", width);
			$$ice(splitEL).ApplyStyle("left", width);
			$$ice(rightEL).ApplyStyle("left", width + splitDim.width);
		}
		else
		{
			$$ice(rightEL).ApplyStyle("width", width);
			$$ice(splitEL).ApplyStyle("right", width);
			$$ice(leftEL).ApplyStyle("right", width + splitDim.width);
		}
	}

	$$ice(splitEL)
	.OnHover(function (sender, ev)
	{
		if (!isCollapsed)
		{
			$$ice(this).ApplyStyle("cursor", "e-resize").ApplyStyle("background-color", hoverColor);
		}
	}
	, function ()
	{
		if (!state)
		{
			$$ice(this).ApplyStyle("cursor", originalCursor).ApplyStyle("background-color", frameColor);
		}
	})
	.OnMouseDown(function (sender, ev)
	{
		if (!isCollapsed)
		{
			$$ice(document.body).SetSelectable(false);
			state = {};
			state.startPageX = ev.pageX;
			state.leftDim = $$ice(leftEL).SelectStyleMap(["width"]).First();
			state.rightDim = $$ice(rightEL).SelectStyleMap(["width"]).First();
		}
	});

	$$ice(document)
	.OnMouseUp(function (sender, ev)
	{
		$$ice(splitEL).ApplyStyle("cursor", originalCursor).ApplyStyle("background-color", frameColor);
		$$ice(document.body).SetSelectable(true);
		state = false;
	})
	.OnMouseMove(function (sender, ev)
	{
		if (state)
		{
			var deltaX = ev.pageX - state.startPageX;
			var newLeftWidth = state.leftDim.width + deltaX;
			var newRightWidth = state.rightDim.width - deltaX;

			if (toLeft)
			{
				if (newLeftWidth < leftMinWidth)
				{
					newLeftWidth = leftMinWidth;
				}
				if (newLeftWidth > leftMaxWidth)
				{
					newLeftWidth = leftMaxWidth;
				}
			}
			else // toRight
			{
				if (newRightWidth < rightMinWidth)
				{
					newRightWidth = rightMinWidth;
				}
				if (newRightWidth > rightMaxWidth)
				{
					newRightWidth = rightMaxWidth;
				}
			}

			if (newLeftWidth >= leftMinWidth && newLeftWidth <= leftMaxWidth && newRightWidth >= rightMinWidth && newRightWidth <= rightMaxWidth)
			{
				if (toLeft)
				{
					SetWidth(newLeftWidth);
				}
				else // toRight
				{
					SetWidth(newRightWidth);
				}
			}
		}
	});

};
