/// <reference path="ice-fix-ext-before.js" />
/// <reference path="Ext_21/source/core/Ext.js" />
/// <reference path="Ext_21/source/adapter/ext-base.js" />
/// <reference path="Ext_21/ext-all-debug.js" />

/********************************************************
	INCLUDE THIS JS AFTER EXT
*********************************************************

/*******************************************************
	START OF Ext.lib.Event MODIFICATION
	
	modified methods (for Opera compatibility)
	doAdd
	doRemove

*******************************************************/

if(window.Ext && Ext.lib && Ext.lib.Event)
{
	Ext.lib.Event.doAdd = function () {
		if(window.attachEvent) // added for Opera compatibility
		{
			window.addEventListener = null;
			window.removeEventListener = null;
		}
		if (window.addEventListener) {
			return function(el, eventName, fn, capture) {
				el.addEventListener(eventName, fn, (capture));
			};
		} else if (window.attachEvent) {
			return function(el, eventName, fn, capture) {
				el.attachEvent("on" + eventName, fn);
			};
		} else {
			return function() {
			};
		}
	}();

	 Ext.lib.Event.doRemove = function() {
		if(window.attachEvent) // added for Opera compatibility
		{
			window.addEventListener = null;
			window.removeEventListener = null;
		}

		if (window.removeEventListener) {
			return function (el, eventName, fn, capture) {
				el.removeEventListener(eventName, fn, (capture));
			};
		} else if (window.detachEvent) {
			return function (el, eventName, fn) {
				el.detachEvent("on" + eventName, fn);
			};
		} else {
			return function() {
			};
		}
		}();
}
/*******************************************************
	END OF Ext.lib.Event MODIFICATION
*******************************************************/
            
/*******************************************************
	START OF Ext.Msg
*******************************************************/

if(window.Ext && Ext.Msg)
{   
	Ext.apply(Ext.Msg, 
	{
		minWidth: 200,
		redAlert: function(title, msg, fn, scope)
		{
			if(typeof(msg) == "object")
			{
				msg = this.createMessage(msg);
			}
			return Ext.Msg.alert("<span style=\"color:red; font-weight:bold;\">" + title + "</span>", msg, fn, scope);
		},
		createMessage: function (error)
		{
			var msg = "";
			for(var property in error)
			{
				if(error[property] && typeof(error[property]) != typeof(Function))
				{
					msg += "<b>" + property + ": </b><br/>" + error[property] + "<br/><br/>";
				}
			}
			return msg;
		}
	});         
 }           

/*******************************************************
	START OF Ext.Msg
*******************************************************/


