/*
 * qWikiOffice Desktop 0.7.1
 * Copyright(c) 2007-2008, Integrated Technologies, Inc.
 * licensing@qwikioffice.com
 * 
 * http://www.qwikioffice.com/license
 *
 * NOTE:
 * This code is based on code from the original Ext JS desktop demo.
 * I have made many modifications/additions.
 *
 * The Ext JS licensing can be viewed here:
 *
 * Ext JS Library 2.0 Beta 2
 * Copyright(c) 2006-2007, Ext JS, LLC.
 * licensing@extjs.com
 * 
 * http://extjs.com/license
 *
 */

QoDesk = new Ext.app.App({
	
	init :function(){
		Ext.QuickTips.init();
	},

	// get modules to initialize (make available to your desktop)
	getModules : function(){
		return [
//			new QoDesk.ControlPanelModule()
			new QoDesk.CurrencyEditorGrid(),
			new QoDesk.CurrencyRetriever(),
//			new QoDesk.LanguageEditorGrid(),
			new QoDesk.WeightUnitEditorGrid(),
			new QoDesk.TaxEditorGrid(),
			new QoDesk.PaymentTypeEditorGrid(),
			new QoDesk.ShippingTypeEditorGrid(),
			new QoDesk.CountryEditorGrid(),
			new QoDesk.StateEditorGrid(),
			new QoDesk.UsersMain(),
			new QoDesk.ProductsMain(),
//			new QoDesk.RoleEditorGrid(),
			new QoDesk.AppGlobalSettingsEditorGrid(),
//			new QoDesk.UsersInRolesEditor(),
			new QoDesk.PagerSizeEditorGrid(),
//			new QoDesk.CampaignEditorGrid(),
//			new QoDesk.ProductsInCategoriesEditor(),
			new QoDesk.ImageGallery(),
			new QoDesk.ManufacturerEditorGrid(),
			new QoDesk.ProductEdit(),
//			new QoDesk.WebPageEditorGrid(),
			new QoDesk.MessageEditorGrid(),
			new QoDesk.OrdersGridModule(),
			new QoDesk.NewsletterComposer(),
			new QoDesk.TablesEditorGridModule()
			
			];
	},
	
	// config for the start menu
    getStartConfig : function(){
    //	var pref = new QoDesk.Preferences();
	//	pref.app = this;
		
        return {
            iconCls: "user",
            title: GService.Username,
            toolItems: [
         //   	pref.launcher,
            {
				text:'Logout',
				iconCls:'exit-icon-small',
				handler:function(){
					///Ext.MessageBox.ShowWaitMessage(true, "Logging-Out...");
					function OnDone(){	window.location = "./"; };
					GService.Logout(OnDone);
				},
				scope:this
			}],
			toolPanelWidth: 115
        };
    },
    
    // get desktop configuration
    getDesktopConfig : function(){
    	/* The next line is being replaced with the config
		 * by os.php */
		//var o = <<config>>;	
		var o = {
			success: true,
			config: {
				// autorun: ["ControlPanelModule"],// ["test1"],// ["qo-preferences","demo-acc"],
				contextmenu: ["qo-preferences", "demo-acc"],
				//	quickstart: ["demo-bogus","demo-acc","demo-grid","demo-tabs","qo-preferences"],
				shortcuts: [
//					"ControlPanelModule", 
					"AppGlobalSettingsEditorGrid",
//					"LanguageEditorGrid", 
					"CurrencyEditorGrid",
					"CurrencyRetrieverEditor",
					"WeightUnitEditorGrid", 
					"TaxEditorGrid", 
					"PaymentTypeEditorGrid", 
					"ShippingTypeEditorGrid", 
					"CountryEditorGrid", 
					"StateEditorGrid", 
					"UsersInRolesEditorGrid",
					"ProductsInCategoriesEditorGrid",
					"PagerSizeEditorGrid", 
//					"RoleEditorGrid", 
//					"UsersInRolesEditorGrid", 
//					"CampaignEditorGrid", 
//					"ProductsInCategoriesGrid",
					"ImageGalleryEditor", 
					"ManufacturersEditorGrid", 
//					"WebPageEditorGrid", 
					"MessageEditorGrid", 
					"OrdersEditorGrid", 
					"NewsletterComposerEditor",
					"TablesEditorGrid"
					],
				
				cpShortcuts: [
					"AppGlobalSettingsEditorGrid", 
//					"LanguageEditorGrid", 
					"CurrencyEditorGrid",
					"CurrencyRetrieverEditor",
					"WeightUnitEditorGrid", 
					"TaxEditorGrid", 
					"PaymentTypeEditorGrid", 
					"ShippingTypeEditorGrid", 
					"CountryEditorGrid", 
					"StateEditorGrid", 
					"UsersInRolesEditorGrid",
					"ProductsInCategoriesEditorGrid",
					"PagerSizeEditorGrid", 
//					"RoleEditorGrid", 
//					"UsersInRolesEditorGrid", 
//					"CampaignEditorGrid", 
//					"ProductsInCategoriesGrid",
					"ImageGalleryEditor", 
					"ManufacturersEditorGrid", 
//					"WebPageEditorGrid", 
					"MessageEditorGrid", 
					"OrdersEditorGrid", 
					"NewsletterComposerEditor",
					"TablesEditorGrid"					
					],
				
				startmenu: [
//					"ControlPanelModule", 
					"AppGlobalSettingsEditorGrid", 
//					"LanguageEditorGrid", 
					"CurrencyEditorGrid",
					"CurrencyRetrieverEditor", 
					"WeightUnitEditorGrid",
					"TaxEditorGrid",
					"PaymentTypeEditorGrid",
					"ShippingTypeEditorGrid",
					"CountryEditorGrid",
					"StateEditorGrid", 
					"UsersInRolesEditorGrid",
					"ProductsInCategoriesEditorGrid",
					"PagerSizeEditorGrid" ,
//					"RoleEditorGrid", 
//					"UsersInRolesEditorGrid", 
//					"CampaignEditorGrid", 
//					"ProductsInCategoriesGrid",
					"ImageGalleryEditor", 
					"ManufacturersEditorGrid",
//					"WebPageEditorGrid", 
					"MessageEditorGrid", 
					"OrdersEditorGrid", 
					"NewsletterComposerEditor",
					"TablesEditorGrid"					
					],
					
				styles: {
					backgroundcolor:  '00586A' /*royal blue2*/,
					"theme-notused": { 
						id: 1,
						name: 'Vista Blue',
						pathtofile: 'resources/themes/xtheme-vistablue/css/xtheme-vistablue.css'
					},
					transparency: false,
////					'wallpaper': {
////						'id': 3,
////						'name': 'blue-swirl',
////						'pathtofile': 'resources/wallpapers/blue-swirl.jpg'
////					},
					wallpaperposition: 'tile'
				}
			}
		};	
			
		if(o.success){
			this.initDesktopConfig(o.config);
		}else{
			// error
		}
		
    	/* can also call server for saved config
    	 *
		Ext.Ajax.request({
			success: function(o){
				var decoded = Ext.decode(o.responseText);
				
				if(decoded.success){
					this.initDesktopConfig(decoded.config);
				}else{
					// error
				}
			},
			failure: function(){
				// error
			},
			scope: this,
			url: 'source/core/DesktopConfig.php'
		}); */
		
		/* can also hard code the config as shown here
		 *
		this.initDesktopConfig({
			'autorun' : [
				'docs-win'
			],
			'contextmenu': [
				'qo-preferences'
    		],
    		'quickstart': [
    			'demo-grid',
				'demo-tabs',
				'demo-acc',
				'demo-layout'
			],
			'shortcuts': [
				'demo-grid',
				'demo-tabs',
				'demo-acc'
			],
			'startmenu': [
				'docs-win',
				'demo-grid',
				'demo-tabs',
				'demo-acc',
				'demo-layout',
				'demo-menu'
			],
			'styles': {
				'backgroundcolor': 'f9f9f9',
				'theme': {
					'id': 2,
					'description': 'Vista Black',
					'path': 'resources/themes/xtheme-vistablack/css/xtheme-vistablack.css'
				},
				'transparency': false,
				'wallpaper': {
					'id': 1,
					'description': 'qWikiOffice',
					'path': 'resources/wallpapers/qwikioffice.jpg'
				},
				'wallpaperposition': 'center'
			}
		}); */
    }
});