﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


QoDesk.AppGlobalSettingsEditorGrid = function(config){
	QoDesk.AppGlobalSettingsEditorGrid.superclass.constructor.apply(this, arguments);
};

QoDesk.AppGlobalSettingsEditorGrid = Ext.extend(QoDesk.AppGlobalSettingsEditorGrid, Ext.app.Module, {

	name: "Application Settings",
	windowId: "AppGlobalSettingsWin",
	moduleType: 'demo',
    moduleId: 'AppGlobalSettingsEditorGrid',
	autoload: true,
	iconCls : "settings-icon-small",
	shortcutIconCls : "settings-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		
		if(win)
		{
			win.show();
		}
		else
        {
			win = desktop.createWindow({
		        id: this.windowId,
                title: this.name,
                width:850,
                height:600,
                //closeAction:'hide',
                iconCls: this.iconCls,
                shim:false,
                animCollapse:false,
                constrainHeader:true,
				layout: 'fit',
                //items: grid,
                taskbuttonTooltip: "<b>" + this.name + "</b>"
			});
			
						
			function LoadGridView()
			{
				var grid = Ice.DbAdmin.GetGridWithPaging({
					tableName:"AppGlobalSetting", 
					delayLoad:100, 
					disableInlineEditing:true,
					hideSchemaInfo:true,
					sortInfo: {field:'Ordinal', direction:'DESC'},
					columns:
					{
						"Description":
						{
							multiline:true
						},
						"SkinDirectory":
						{
							header:"SkinDirectory",
							dataIndex:"SkinDirectory",
							hidden:false,
							renderer: skinDirectory.renderer,
							formEditor: Ext.grid.SkinDirectoryField	
						},
						"SSLModeID": 
						{
							header:"SSL Mode", 
							dataIndex:"SSLModeID", 
							hidden:false,
							renderer: sslMode.renderer, // grid renderer
							formEditor: Ext.grid.SSLModeField,
							formRequired:true // form red field
						},
						"TaxID": 
						{
							header:"Default Tax", 
							dataIndex:"TaxID", 
							hidden:false,
							renderer: taxEditor.renderer, // grid renderer
							formEditor: Ext.grid.TaxField
						},
						"CountryID":{
							header:"Default Country", 
							dataIndex:"CountryID", 
							hidden:false,
							renderer: countyEditor.renderer,
							formEditor: Ext.grid.CountryField
						},
						"StateID":{
							header:"Default State", 
							dataIndex:"StateID", 
							hidden:false,
							renderer: stateEditor.renderer,
							formEditor: Ext.grid.StateField
						},
						"CurrencyID": 
						{
							header:"Default Currency", 
							dataIndex:"CurrencyID", 
							hidden:false,
							renderer: currencyEditor.renderer, // grid renderer
							formEditor: Ext.grid.CurrencyField
						},
						"WeightUnitID":{
							header:"Default WeightUnit", 
							dataIndex:"WeightUnitID", 
							hidden:false,
							renderer: weightEditor.renderer,
							formEditor: Ext.grid.WeightUnitField
						},
						"ShippingTypeID": 
						{
							header:"Default ShippingType", 
							dataIndex:"ShippingTypeID", 
							hidden:false,
							renderer: shippingTypeEditor.renderer, // grid renderer
							formEditor: Ext.grid.ShippingTypeField
						},
						"PaymentTypeID":{
							header:"Default PaymentType", 
							dataIndex:"PaymentTypeID", 
							hidden:false,
							renderer: paymentTypeEditor.renderer,
							formEditor: Ext.grid.PaymentTypeField
						},
						"PagerSizeID":{
							header:"Default PagerSize", 
							dataIndex:"PagerSizeID", 
							hidden:false,
							renderer: pagerSizeEditor.renderer,
							formEditor: Ext.grid.PagerSizeField
						}
					
					}
				});
				
				function Refreshed()
				{
					win.nextDirection = win.nextDirection == 1 ? -1 : 1;
					win.width += win.nextDirection;
					win.setWidth(win.width); // have to re-render window after data is loaded					
				}
				grid.view.on("refresh", function(){ setTimeout(Refreshed, 1000);});
				
				win.add(grid);
				win.show();
	//			win.render();
			}
			
			var skinDirectory = new Ext.grid.SkinDirectoryField();
			var sslMode = new Ext.grid.SSLModeField();
			var countyEditor = new Ext.grid.CountryField();
			var stateEditor = new Ext.grid.StateField();
			var taxEditor = new Ext.grid.TaxField();
			var currencyEditor = new Ext.grid.CurrencyField();
			var weightEditor = new Ext.grid.WeightUnitField();
			var shippingTypeEditor = new Ext.grid.ShippingTypeField();
			var paymentTypeEditor = new Ext.grid.PaymentTypeField();
			var pagerSizeEditor = new Ext.grid.PagerSizeField();
			
			function CombosLoader()
			{
				if(taxEditor.dataLoaded 
					&& countyEditor.dataLoaded 
					&& weightEditor.dataLoaded 
					&& shippingTypeEditor.dataLoaded 
					&& paymentTypeEditor.dataLoaded 
					&& pagerSizeEditor.dataLoaded)
				{
					LoadGridView();
				}
				else
				{
					setTimeout(CombosLoader, 100);
				}
			}
			
			CombosLoader();
        }
      
    }
 });
 
