﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />

Ext.grid.GComboDataStores = {};

Ext.grid.GCombo = function(){
	Ext.grid.GCombo.superclass.constructor.apply(this, arguments);
	var __this = this;
	
	this.renderer = 	function (a, b, record, d, e, f){ // record is from grid.store
	
		var idValue = record.get(__this.valueField);
		var rec = __this.findRecord(__this.valueField, idValue);
		if(rec)
		{
			return rec.get(__this.displayField);
		}
		return "";
	};
	
	var LoadDataStore = function(){
		var store = Ext.grid.GComboDataStores[__this.dbTable];
		if(store && store.dataLoaded)
		{
			__this.store = store;
			__this.dataLoaded = store.dataLoaded;
		}
		else
		{
			GService["Get" + __this.dbTable + "Collection"](function(data){
				var rec = {};
				rec[__this.valueField] = null;
				rec[__this.displayField] = "- not set -";
			
				data.unshift(rec);
				
				__this.store = store = new Ext.data.Store({
					reader: new Ext.data.JsonReader(
						{},
						[
							{name: __this.valueField},
							{name: __this.displayField},
						])
					});
					
				store.loadData(data);
				__this.dataLoaded = store.dataLoaded = true;
				
				Ext.grid.GComboDataStores[__this.dbTable] = store;
			});
		}
	};
	
	LoadDataStore();
	
};

Ext.grid.GCombo = Ext.extend(Ext.grid.GCombo, Ext.form.ComboBox, {
	typeAhead: true,
	triggerAction: 'all',
	lazyRender:true,
	editable:false,
	width:150,
	mode:"local",
	dbTable:"Tax",
	displayField:"Name",
	//valueField: "TaxID",
	dataLoaded:false,
	getValue: function(){
		var value = Ext.grid.GCombo.superclass.getValue.call(this);
		if(value == "- not set -")
		{
			value = "";
		}
		return value;
	},
	setValue: function(value){
		return Ext.grid.GCombo.superclass.setValue.call(this, value);
	}
	
});



//***************************************************

Ext.grid.TaxField = function(){
	return new Ext.grid.GCombo({
		valueField:"TaxID",
		dbTable:"Tax"
	});
};

Ext.grid.CountryField = function(){
	return new Ext.grid.GCombo({
		valueField : "CountryID",
		dbTable : "Country",
		width:200
	});
};

Ext.grid.StateField = function(){
	return new Ext.grid.GCombo({
		valueField : "StateID",
		dbTable : "State",
		width:200
	});
};

Ext.grid.CurrencyField = function(){
	return new Ext.grid.GCombo({
		valueField : "CurrencyID",
		dbTable : "Currency",
		width:200
	});
};

Ext.grid.WeightUnitField = function(){
	return new Ext.grid.GCombo({
		valueField : "WeightUnitID",
		dbTable : "WeightUnit"
	});
};

Ext.grid.ShippingTypeField = function(){
	return new Ext.grid.GCombo({
		valueField : "ShippingTypeID",
		dbTable : "ShippingType",
		width:200
	});
};

Ext.grid.PaymentTypeField = function(){
	return new Ext.grid.GCombo({
		valueField : "PaymentTypeID",
		dbTable : "PaymentType",
		width:200
	});
};

Ext.grid.PagerSizeField = function(){
	return new Ext.grid.GCombo({
		valueField : "PagerSizeID",
		dbTable : "PagerSize"
	});
};

Ext.grid.SkinDirectoryField = function(){
	return new Ext.grid.GCombo({
		valueField : "SkinDirectory",
		dbTable : "SkinDirectory"
	});
};

Ext.grid.SSLModeField = function(){
	return new Ext.grid.GCombo({
		valueField : "SSLModeID",
		dbTable : "SSLMode"
	});
};

Ext.grid.OrderStatusField = function(){
	return new Ext.grid.GCombo({
		valueField : "OrderStatusEnumId",
		dbTable : "OrderStatus"
	});
};

Ext.grid.PaymentStatusField = function(){
	return new Ext.grid.GCombo({
		valueField : "PaymentStatusEnumId",
		dbTable : "PaymentStatus"
	});
};

Ext.grid.CategoryShortcutField = function(){
	return new Ext.grid.GCombo({
		//valueField : "ShortcutName",
		width:200,
		dbTable : "CategoryShortcut"
	});
};


