﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


QoDesk.CurrencyEditorGrid = function(config){
	QoDesk.CurrencyEditorGrid.superclass.constructor.apply(this, arguments);
};

QoDesk.CurrencyEditorGrid = Ext.extend(QoDesk.CurrencyEditorGrid, Ext.app.Module, {

	name: "Currencies",
	windowId: "CurenciesWin",
	moduleType: 'demo',
    moduleId: 'CurrencyEditorGrid',
	autoload: true,
	iconCls : "currency-icon-small",
	shortcutIconCls : "currency-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		
		if(win)
		{
			win.show();
		}
		else
        {
			win = desktop.createWindow({
		        id: this.windowId,
                title: this.name,
                width:850,
                height:600,
                //closeAction:'hide',
                iconCls: this.iconCls,
                shim:false,
                animCollapse:false,
                constrainHeader:true,
				layout: 'fit',
                //items: grid,
                taskbuttonTooltip: "<b>" + this.name + "</b>"
			});
			
			var grid = Ice.DbAdmin.GetGridWithPaging({
				tableName:"Currency", 
				delayLoad:500, 
				disableInlineEditing:true,
				sortInfo: {field:'Ordinal', direction:'DESC'},
				hideSchemaInfo:true
			});
			
			function Refreshed()
			{
				win.nextDirection = win.nextDirection == 1 ? -1 : 1;
				win.width += win.nextDirection;
				win.setWidth(win.width); // have to re-render window after data is loaded					
			}
			grid.view.on("refresh", function(){ setTimeout(Refreshed, 1000);});

			win.add(grid);
			win.show();

        }
        
    }
 });
 
