/// <reference path="../language/en.js" />

QoDesk.CurrencyRetriever = Ext.extend(Ext.app.Module, {
	name:CartLanguage.CurrencyRetriever,
	windowId:"CurrencyRetrieverWin",
	ajaxNs: "CurrencyRetriever",
	moduleType: 'demo',
    moduleId: 'CurrencyRetrieverEditor',
	iconCls: "currencyRetriever-icon-small",
	shortcutIconCls: "currencyRetriever-icon-large",

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls || 'icon-grid',
            scope: this,
            shortcutIconCls: this.shortcutIconCls || 'demo-grid-shortcut',
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
		var __this = this;
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
        
        if(!win)
        {
			
			// load AppGlobalSettings
			function LoadData()
			{
				//AjaxRequestStarted();
				
				GService.GetDefaultCurrency(function(currency)
				{
					var items = [];
					
					var html =  "<div align='center' style='padding:10px 0 5px 0; font-size:12px;'>" + 
											CartLanguage.DefaultCurrency +  ": <b>" + currency.ISOCode + " - " + currency.Name + "</b>" + 
											"<br/><br/>" + 
											"<div>" + CartLanguage.CurrencyRetrieverNote + "</div>" + 
											"<br/><br/>" + 
											"<div>" + CartLanguage.CurrencyRateProvider + ": <a href='http://www.xe.com/' target='_blank'>http://www.xe.com/</a></div>" +
											
											"</div>";
					
					var item = new Ext.form.Label({html: html});
					items.push(item);
					
					var buttonRetrieve = 
					{
						text: "<b>" + CartLanguage.Retrieve +"</b>",
						handler: function()
						{
							formPanel.buttons[0].setText("<b>" + CartLanguage.Retrieving + "</b>");
							formPanel.buttons[0].disable();
							
							//Ext.MessageBox.ShowWaitMessage(true, CartLanguage.Retrieving);
							GService.UpdateCurrencyRatesFromCurrencyServer(function(result)
							{
								formPanel.buttons[0].setText("<b>" + CartLanguage.Retrieve + "</b>");
								formPanel.buttons[0].enable();
								
								//Ext.MessageBox.ShowWaitMessage(false);
								
								if(result.Success)
								{
									Ext.Msg.show({
									   title:CartLanguage.Success,
									   msg: result.Message,
									   buttons: Ext.Msg.OK,
									   icon: Ext.MessageBox.INFO
									});
								}
								else
								{
									Ext.Msg.show({
									   title:CartLanguage.Failed,
									   msg: result.Message,
									   buttons: Ext.Msg.OK,
									   icon: Ext.MessageBox.ERROR
									});

								}
							});
						}
					};
					
					var formPanel = new Ext.FormPanel({
							labelWidth: 105, // label settings here cascade unless overridden
						   // frame:true,
							hideBorders: true,
							autoScroll: true,
							bodyStyle: "background-color:#ECECEC; padding: 10px 0 0 5px;",
							defaults: {width: 230},
							items: items,
							defaultType: 'textfield',
							buttons: [
								buttonRetrieve,
							{
								text: '<b>' + CartLanguage.Close + '</b>',
								handler: function()
								{
									win.close();
								}
							}]
						});
					
					win = desktop.createWindow({
						id: __this.windowId,
						title: __this.name,
						width:450,
						height:250,
						iconCls: __this.iconCls || 'icon-grid',
						shim:false,
						animCollapse:false,
						constrainHeader:true,
						layout: 'fit',
						items: formPanel,
						taskbuttonTooltip: "<b>" + __this.winTitle + "</b>"
					});
					
					//AjaxRequestEnded();
					
					win.show();
				});
			}
			
			LoadData();
        }
        else
        {
			win.show();
		}
    }
    
});

