﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="../IceExtExtensions.js" />
/// <reference path="/Scripts/IceFormSerialization.js" />

Ice.DbAdmin.OrderEditorForm = function(config){

	//alert("ShowFormAddNew");
	/*
	config is the same as GridWithPaging plus some extra properties:
		config.animateTarget = sender;
		config.onSaved = AfterSaveMethod;
		config.record = record;
		config.forceInsert = forceInsert;
		config.iconCls = iconCls;
	*/
	
	var data = config.record ? (config.record.data || {}) : {};
	var divId = "order_" + data.OrderID + new Date().getTime();

	var orderStatus = new Ext.grid.OrderStatusField();
	orderStatus.setValue(data.OrderStatusEnumId);

	var paymentStatus = new Ext.grid.PaymentStatusField();
	paymentStatus.setValue(data.PaymentStatusEnumId);
	
	function GetFormPanel(html)
	{		
		var formPanel = new Ext.FormPanel({
			labelAlign: 'top',
			bodyStyle:'padding:0px',
			
			border:false,
			autoScroll: true,
			items: 
			[
				{
					border:false,
					html:"<div id='printableDiv'>" + html + "</div>"
				},
				{
					layout:"column",
					border:false,
					width: 580,
					style:"margin:10px; padding:5px; background-color:#ECECEC;",
					items:
					[
						{
							border:false,
							columnWidth:.17,
							style:"padding:5px; font-weight:bold;",
							html: "OrderStatus:"
						},
						{
							border:false,
							columnWidth:.30,
							items:orderStatus
						},
						{
							border:false,
							columnWidth:.20,
							style:"padding:5px; font-weight:bold;",
							html: "PaymentStatus:"
						},
						{
							border:false,
							columnWidth:.30,
							items:paymentStatus
						}
					]
				}
			]
		});
		return formPanel;
	}
	
	function PrintContent(elementId)
	{
		var win = window.open("", "printContent", "width=800px, height=600px, resizable=yes, status=no, scrollbars=yes");
		
		win.document.write(	"<html><head><style>	body, table {font-size:12px};</style></head><body style='margin:40px; background-color:white;'> document.getElementById(elementId).innerHTML;</body></htm>");
		/*
				win.document.write(	"<html><head>" +
							"<" + "style" + ">\
							body, table {font-size:12px};\
							</" + "style" + ">" +
							"</head>" + 
							"<body style='margin:40px; background-color:white;'>" +
							 document.getElementById(elementId).innerHTML + 
							"</body>" + 
							"</htm>"  );
		*/
		
		win.document.close();
		win.print();
		win.close();			
	}
						
	function GetWindow(html)
	{
		var win = new Ext.Window({

			title: 'Order no: ' + data.OrderID,
			minimizable:false,
			modal:true,
			maximizable:false,
			resizable:true,
			closable:true,
			maximized:false,
			iconCls: config.iconCls,
			border:true,
			width: 635,
			height: 600,
			shim:false,
			closeAction:'hide',
			animCollapse:true,
			autoScroll: true,
			layout: 'fit',
			bodyStyle: "dbackground-color:#ECECEC; padding:0px;",
			items: GetFormPanel(html),
			buttons: 
			[
				{
					text: "Print",
					iconCls:"icon_printer",
					handler: function()
					{
						PrintContent("printableDiv");
					}
				},
				{
					text: "Update",
					iconCls:"icon_table_save",
					handler: function()
					{
						config.record.set("OrderStatusEnumId", orderStatus.getValue());
						config.record.set("PaymentStatusEnumId", paymentStatus.getValue());
						//config.record.commit();

						GService.UpdateRows(config.tableName, [config.record.data], function(newRows){
							if(newRows && newRows.length > 0)
							{
								win.hide();
								win.onFormSaved(newRows);
							}						
						});
					}
				},
				{
					text: "Close",
					iconCls:"icon_cancel",
					handler: function()
					{
						win.hide();
					}
				}
			]
		});

		win.currentRecord = config.record;
		win.onFormSaved = config.onSaved;
		
		return win;
	}
	
	function LoadOrderData(orderID)
	{
		GService.GetOrderHtml(orderID,function(html){
			var win = GetWindow(html);
			win.show();
		});
	}

	// load order data
	LoadOrderData(config.record.data.OrderID);
	
};


