﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


QoDesk.OrdersGridModule = function(config){
	QoDesk.OrdersGridModule.superclass.constructor.apply(this, arguments);
};

QoDesk.OrdersGridModule = Ext.extend(QoDesk.OrdersGridModule, Ext.app.Module, {

	name: "Orders",
	windowId: "OrdersWin",
	moduleType: 'demo',
    moduleId: 'OrdersEditorGrid',
	iconCls : "orders-icon-small",
	shortcutIconCls : "orders-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		
		if(win)
		{
			win.show();
		}
		else
        {
			win = desktop.createWindow({
		        id: this.windowId,
                title: this.name,
                width:850,
                height:600,
                //closeAction:'hide',
                iconCls: this.iconCls,
                shim:false,
                animCollapse:false,
                constrainHeader:true,
				layout: 'fit',
                //items: grid,
                taskbuttonTooltip: "<b>" + this.name + "</b>"
			});
			
			
			function DeleteRecords(tableName, arrayData, onDone)
			{	
				var orderIds = [];
				for(var n = 0; n < arrayData.length; n++)
				{
					orderIds.push(arrayData[n].OrderID);
				}
				GService.DeleteOrders(orderIds, onDone);
			}
						
			function LoadGridView()
			{
				var grid = Ice.DbAdmin.GetGridWithPaging({
					tableName:"Order", 
					delayLoad:100, 
					disableInlineEditing:true,
					hideSchemaInfo:true,
					hideNew: true,
					customForm: Ice.DbAdmin.OrderEditorForm,
					methodDelete: DeleteRecords,
					sortInfo: {field:'OrderID', direction:'DESC'},
					columns:
					{
						"ShippingTypeID": 
						{
							header:"ShippingType", 
							dataIndex:"ShippingTypeID", 
							hidden:false,
							renderer: shippingTypeEditor.renderer, // grid renderer
							formEditor: Ext.grid.ShippingTypeField
						},
						"PaymentTypeID":{
							header:"PaymentType", 
							dataIndex:"PaymentTypeID", 
							hidden:false,
							renderer: paymentTypeEditor.renderer,
							formEditor: Ext.grid.PaymentTypeField
						},
						"OrderStatusEnumId": 
						{
							header:"OrderStatus", 
							dataIndex:"OrderStatusEnumId", 
							hidden:false,
							renderer: orderStatus.renderer, // grid renderer
							formEditor: Ext.grid.OrderStatusField
						},
						"PaymentStatusEnumId":{
							header:"PaymentStatus", 
							dataIndex:"PaymentStatusEnumId", 
							hidden:false,
							renderer: paymentStatus.renderer,
							formEditor: Ext.grid.PaymentStatusField
						},
						"PaymentGatewayData":{
							multiline:true
						}
					
					}
				});
				
				function Refreshed()
				{
					win.nextDirection = win.nextDirection == 1 ? -1 : 1;
					win.width += win.nextDirection;
					win.setWidth(win.width); // have to re-render window after data is loaded					
				}
				grid.view.on("refresh", function(){ setTimeout(Refreshed, 1000);});
				
				win.add(grid);
				win.show();
	//			win.render();
			}
			
			var orderStatus = new Ext.grid.OrderStatusField();
			var paymentStatus = new Ext.grid.PaymentStatusField();
			var shippingTypeEditor = new Ext.grid.ShippingTypeField();
			var paymentTypeEditor = new Ext.grid.PaymentTypeField();
			
			function CombosLoader()
			{
				if(shippingTypeEditor.dataLoaded 
					&& paymentTypeEditor.dataLoaded
					&& orderStatus.dataLoaded
					&& paymentStatus.dataLoaded)
				{
					LoadGridView();
				}
				else
				{
					setTimeout(CombosLoader, 100);
				}
			}
			
			CombosLoader();
        }
      
    }
 });
 
