﻿/// <reference path="../ice-fix-ext-before.js" />
/// <reference path="../Ext_21/source/core/Ext.js" />
/// <reference path="../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../Ext_21/ext-all-debug.js" />
/// <reference path="../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


QoDesk.StateEditorGrid = function(config){
	QoDesk.StateEditorGrid.superclass.constructor.apply(this, arguments);
};

QoDesk.StateEditorGrid = Ext.extend(QoDesk.StateEditorGrid, Ext.app.Module, {

	name: "States",
	windowId: "StatesWin",
	moduleType: 'demo',
    moduleId: 'StateEditorGrid',
	autoload: true,
	iconCls : "state-icon-small",
	shortcutIconCls : "state-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		var __this = this;
		
		if(win)
		{
			win.show();
		}
        else
        {
			
			win = desktop.createWindow({
				id: __this.windowId,
				title: __this.name,
				width:850,
				height:600,
				//closeAction:'hide',
				iconCls: __this.iconCls,
				shim:false,
				animCollapse:false,
				constrainHeader:true,
				layout: 'fit',
				//items: grid,
				taskbuttonTooltip: "<b>" + __this.name + "</b>"
			});
			
	        
	        function LoadGridView()
	        {
        		var grid = Ice.DbAdmin.GetGridWithPaging({
					tableName:"State", 
					delayLoad:0, 
					disableInlineEditing:true,
					hideSchemaInfo:true,
					sortInfo: {field:'Ordinal', direction:'DESC'},
					columns:
					{
						"TaxID": 
						{
							width:100,
							header:"Tax", 
							dataIndex:"TaxID", 
							hidden:false,
							renderer: taxEditor.renderer, // grid renderer
							formEditor: Ext.grid.TaxField
						},
						"CountryID":{
							width:150,
							header:"Country", 
							dataIndex:"CountryID", 
							hidden:false,
							renderer: countyEditor.renderer,
							formEditor: Ext.grid.CountryField
						}

					}
				});
				
				function Refreshed()
				{
					win.nextDirection = win.nextDirection == 1 ? -1 : 1;
					win.width += win.nextDirection;
					win.setWidth(win.width); // have to re-render window after data is loaded					
				}
				grid.view.on("refresh", function(){ setTimeout(Refreshed, 1000);});

				
				win.add(grid);
		        win.show();
	//			win.render();
			}
			
			var countyEditor = new Ext.grid.CountryField();
			var taxEditor = new Ext.grid.TaxField();
			
			function CombosLoader()
			{
				if(taxEditor.dataLoaded && countyEditor.dataLoaded)
				{
					LoadGridView();
				}
				else
				{
					setTimeout(CombosLoader, 100);
				}
			}
			
			CombosLoader();
        }   
    }
 });
 
 
