﻿
///////////////////////////////////////////////////////////////////////////////////////////////
// GENERAL SELECTOR
QoDesk.SettingsSelectorMod = function (identity)
{
	var identity = identity;

	QoDesk.SettingsSelectorMod.superclass.constructor.call(this, {
		emptyText: '-- ? --',
		validationEvent: false,
		validateOnBlur: false,
		msgTarget: 'under',
		lazyRender: true,
		triggerAction: 'all',
		displayField: 'Name',
		mode: 'local',
		width: 150,
		editable: false,

		tpl: new Ext.XTemplate(
                '<tpl for="."><div class="x-combo-list-item ux-icon-combo-item ">',
               '&nbsp;<strong>{Name}</strong>',
                '<div class="x-clear"></div>',
                '</div></tpl>'),

		store: new Ext.data.Store({
			reader: new Ext.data.JsonReader(
					{
				},
					[
						{ name: "Name", type: "string" },
						{ name: identity + "ID" }
					])
		})

	});

	var combo = this;
	combo.value = CartLanguage.Loading;

	combo.SelectByID = function (ID)
	{
		var total = combo.store.getTotalCount();
		var rec = combo.store.getRange();
		for (var n = 0; n < total; n++)
		{
			if (rec[n].get(identity + "ID") == ID)
			{
				combo.setValue(rec[n].get("Name"));
				combo.CurrentID = ID;
				return true;
			}
		}
		return false;
	};

	combo.on("select", function (a, b, c, d, e)
	{
		combo.CurrentID = b.data[identity + "ID"];
	});

	combo.getText = combo.getValue;

	combo.getValue = function ()
	{
		if (combo.value == CartLanguage.Loading)
		{
			// still loading
			return CartLanguage.Loading;
		}
		else
		{
			return combo.CurrentID;
		}
	};

	combo.OnDataReceived = function (a, b, c, d)
	{
		combo.setValue(""); // remove Loading...
		if (combo.store == null)
		{
			return;
		}
		combo.hasFocus = false; // disable auto expanding
		combo.store.removeAll();

		var m = Ice.Ext.GetMetaData(a, combo.store);

		combo.store.loadData(m);

		if (combo.OnLoaded != null)
		{
			combo.OnLoaded();
		}
	};

	function LoadData()
	{
		var method = "Get" + identity + "CollectionActiveOnly";
		GService[method](combo.OnDataReceived);
	}

	// public event
	combo.OnLoaded = null;
	combo.LoadData = LoadData;
};

QoDesk.SettingsSelectorMod = Ext.extend(QoDesk.SettingsSelectorMod, Ext.form.ComboBox);


//******************************************************
// STORE METADATA CREATOR

Ice.Ext.GetMetaData = function(records, store)
{
	var rec = records[0] || {};
	var fieldsInRec = {};
	
	for(var prop in rec)
	{
		fieldsInRec[prop] = true;
	}
	
	var fieldsNew = [];
	
	// remove fields (mark false) from fieldsInRec which already exist in store.fields.items
	for(var n = 0; n < store.fields.items.length; n++)
	{
		var item = store.fields.items[n];
		fieldsInRec[item.name] = false;
		fieldsNew.push(item);
	}
	
	// add new fields
	for(var prop in fieldsInRec)
	{
		if(fieldsInRec[prop] == true)
		{
			fieldsNew.push({name:prop});
		}
	}
	
	var m = 
	{
		metaData:
		{
			totalProperty: 'totalRecords',
			root: 'collection',
			fields: fieldsNew
		},
		totalRecords: 0,
		collection: records
	};
	
	return m;	
	
};

//******************************************************
