﻿/// <reference path="../../ice-fix-ext-before.js" />
/// <reference path="../../Ext_21/source/core/Ext.js" />
/// <reference path="../../Ext_21/source/adapter/ext-base.js" />
/// <reference path="../../Ext_21/ext-all-debug.js" />
/// <reference path="../../ice-fix-ext-after.js" />
/// <reference path="DbAdminNamespace.js" />
/// <reference path="FormAddNew.js" />


QoDesk.TablesEditorGridModule = function(config){
	QoDesk.TablesEditorGridModule.superclass.constructor.apply(this, arguments);
};

QoDesk.TablesEditorGridModule = Ext.extend(QoDesk.TablesEditorGridModule, Ext.app.Module, {

	name: "Tables Editor",
	windowId: "TablesEditorGridWin",
	moduleType: 'demo',
    moduleId: 'TablesEditorGrid',
	autoload: true,
	iconCls : "tablesEditor-icon-small",
	shortcutIconCls : "tablesEditor-icon-large" ,

    init : function(){
        this.launcher = {
            handler : this.createWindow,
            iconCls: this.iconCls,
            scope: this,
            shortcutIconCls: this.shortcutIconCls,
            text: this.name,
            tooltip: "<b>" + this.name + "</b>"
        }
    },

    createWindow : function(){
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow(this.windowId);
		
		if(win)
		{
			win.show();
		}
        else
        {
			var grid = Ice.DbAdmin.GetGridWithPaging({
				multiline:true,
				formNameBase: "Tables"
			});
			
			win = desktop.createWindow({
		        id: this.windowId,
                title: this.name,
                width:850,
                height:600,
                //closeAction:'hide',
                iconCls: this.iconCls,
                shim:false,
                animCollapse:false,
                constrainHeader:true,
				layout: 'fit',
                items: grid,
                taskbuttonTooltip: "<b>" + this.name + "</b>"
			});
		
			function Refreshed()
			{
				win.nextDirection = win.nextDirection == 1 ? -1 : 1;
				win.width += win.nextDirection;
				win.setWidth(win.width); // have to re-render window after data is loaded					
			}
			grid.view.on("refresh", function(){ setTimeout(Refreshed, 1000);});
			
			win.show();
        }
    }
 });